#!/bin/sh -e
set -e
. ../../define/PATH
. ../../define/FUNCTION_SCRIPT
PATH=${CROSSDIR}:${PATH}
function SEARCH_AND_REPLACE {
	if [ -f "$1" ]; then
		filename=$1
		target_old=$2
		target_new=$3
		target_line=`cat $filename | grep -n "$2" | cut -f 1 -d :`
		if [ "$target_line" ]; then
			total_line=`cat $filename | wc -l`
			cat $filename | head -n `expr $target_line - 1` > ${filename}_temp
			echo "$target_new" >> ${filename}_temp
			cat $filename | tail -n `expr $total_line - $target_line` >> ${filename}_temp
			cat ${filename}_temp > $filename
			rm -rf ${filename}_temp
		fi
	fi
}
if [ "$_Customer30_" ]; then
	cp .config_Customer30 .config -f
elif [ "$_MODE_" = "Customer" ]; then
	cp .config_Buffalo .config -f
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258GNL" ]; then
        cp .config_General .config -f
elif [ "$_USB_8712_" ]; then
	cp .config_Customer .config -f
else
	cp .config_normal .config -f
fi
if [ "$_MODE_" = "Customer" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_ARPING" "CONFIG_ARPING=y"
fi
if [ "$_MODE_" = "Customer" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_KLOGD" "CONFIG_KLOGD=y"
fi
if [ "$_SUPPORT_REMOTE_SYSLOGD_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_REMOTE_LOG" "CONFIG_FEATURE_REMOTE_LOG=y"
fi
if [ "$_LANGUAGE_PACK_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_GUNZIP" "CONFIG_GUNZIP=y"
	SEARCH_AND_REPLACE .config "CONFIG_GZIP" "CONFIG_GZIP=y"
fi
if [ "$_USB_SERVER_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_INSMOD" "CONFIG_INSMOD=y"
	SEARCH_AND_REPLACE .config "CONFIG_RMMOD" "CONFIG_RMMOD=y"
	SEARCH_AND_REPLACE .config "CONFIG_LSMOD" "CONFIG_LSMOD=y"
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_LSMOD_PRETTY_2_6_OUTPUT" "CONFIG_FEATURE_LSMOD_PRETTY_2_6_OUTPUT=y"
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_2_6_MODULES" "CONFIG_FEATURE_2_6_MODULES=y"
	SEARCH_AND_REPLACE .config "CONFIG_DEFAULT_MODULES_DIR" "CONFIG_DEFAULT_MODULES_DIR=/lib/modules"
	SEARCH_AND_REPLACE .config "CONFIG_DEFAULT_DEPMOD_FILE" "CONFIG_DEFAULT_DEPMOD_FILE=modules.dep"
	SEARCH_AND_REPLACE .config "CONFIG_HOSTNAME" "CONFIG_HOSTNAME=y"
fi
if [ "$_IPV6_SUPPORT_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_IPV6" "CONFIG_FEATURE_IPV6=y"
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_PREFER_IPV4_ADDRESS" "CONFIG_FEATURE_PREFER_IPV4_ADDRESS=y"
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_IP_TUNNEL" "CONFIG_FEATURE_IP_TUNNEL=y"
	# SEARCH_AND_REPLACE .config "CONFIG_PING6" "CONFIG_PING6=y"
	SEARCH_AND_REPLACE .config "CONFIG_AWK" "CONFIG_AWK=y"
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_AWK_MATH" "CONFIG_FEATURE_AWK_MATH=y"
	SEARCH_AND_REPLACE .config "CONFIG_SED" "CONFIG_SED=y"
	# SEARCH_AND_REPLACE .config "CONFIG_IP=y" "# CONFIG_IP is not set"
	# SEARCH_AND_REPLACE .config "CONFIG_FEATURE_IP_ADDRESS=y" "# CONFIG_FEATURE_IP_ADDRESS is not set"
	# SEARCH_AND_REPLACE .config "CONFIG_FEATURE_IP_LINK=y" "# CONFIG_FEATURE_IP_LINK is not set"
	# SEARCH_AND_REPLACE .config "CONFIG_FEATURE_IP_ROUTE=y" "# CONFIG_FEATURE_IP_ROUTE is not set"
	# SEARCH_AND_REPLACE .config "CONFIG_FEATURE_IP_TUNNEL=y" "# CONFIG_FEATURE_IP_TUNNEL is not set"
	# SEARCH_AND_REPLACE .config "CONFIG_FEATURE_IP_RULE=y" "# CONFIG_FEATURE_IP_RULE is not set"
	if [ "$_IPV6_6RD_SUPPORT_" ]; then
		SEARCH_AND_REPLACE .config "CONFIG_NSLOOKUP" "CONFIG_NSLOOKUP=y"
	fi
fi
if [ "$_TELNET_DAEMON_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_TELNETD" "CONFIG_TELNETD=y"
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_TELNETD_STANDALONE" "CONFIG_FEATURE_TELNETD_STANDALONE=y"
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_DEVPTS" "# CONFIG_FEATURE_DEVPTS is not set"
fi
if [ "$_WanAutoDetect_" ] || [ "$_IQSETUP_" ] || [ "$_QUICK_MODE_TYPE_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_HTTPD" "CONFIG_HTTPD=y"
	SEARCH_AND_REPLACE .config "CONFIG_FEATURE_HTTPD_CGI" "CONFIG_FEATURE_HTTPD_CGI=y"
fi
if [ "$_WAKEONLAN_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_ETHER_WAKE" "CONFIG_ETHER_WAKE=y"
fi
if [ "$_DHCP_RELAY_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_APP_DHCPRELAY" "CONFIG_APP_DHCPRELAY=y"
fi
if [ "$_WIRELESS_SCHEDULE_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_CROND" "CONFIG_CROND=y"
fi
if [ "$_EZ_QOS_" ]; then
	SEARCH_AND_REPLACE .config "CONFIG_FTPPUT" "CONFIG_FTPPUT=y"
	SEARCH_AND_REPLACE .config "CONFIG_WGET" "CONFIG_WGET=y"
fi
SEARCH_AND_REPLACE .config "CONFIG_ETHER_WAKE" "CONFIG_ETHER_WAKE=y"

case "$1" in
	"clean")
		MAKECLEAR=1
		MAKING=0
	;;
	"make")
		MAKECLEAR=0
		MAKING=1
	;;
esac
if [ "$MAKECLEAR" = 1 ]; then
	rm -rf _install
	make CC=${CROSS}gcc clean
fi
if [ "$MAKING" = 1 ]; then
	./go
fi
