#!/bin/sh
. /bin/scriptlib.sh
SCRIPT_TITLE="Access Control"
debug_print "Cleaning previous status."
if [ -f /var/clean_accesscontrol.sh ]; then
chmod 777 /var/clean_accesscontrol.sh
/var/clean_accesscontrol.sh
rm -rf /var/clean_accesscontrol.sh
fi
debug_print "Checking whether Firewall is enabled."
if [ "$FIREWALL_ENABLE" = "0" ]; then
debug_print "Firewall is disabled, exit."
exit 0
else
debug_print "Firewall is enabled."
fi
GETMIB="flash get"
TMP_FILE=/var/ipfilter
eval `$GETMIB ACPC_ENABLED`
eval `$GETMIB ACPC_TBL_NUM`
eval `$GETMIB IPDENY_ENABLED`
eval `$GETMIB MACFILTER_ENABLED`
eval `$GETMIB MACFILTER_TBL_NUM`
eval `$GETMIB MACDENY_ENABLED`
if [ "$IPDENY_ENABLED" = "" ]; then
IPDENY_ENABLED=0;
fi
if [ "$_KERNEL_VERSION_26_" = "y" ]; then
MPORT=multiport;
else
MPORT=mport;
fi
OK_LETS_DO_IT=0
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
if [ "$ACPC_ENABLED" = "1" ] || [ "$PORTFILTER_ENABLE" = "1" ]; then
OK_LETS_DO_IT=1
fi
else
if [ "$ACPC_ENABLED" = 1 ] && [ $ACPC_TBL_NUM -gt 0 ]; then
OK_LETS_DO_IT=1
fi
fi
if [ "$OK_LETS_DO_IT" = 1 ]; then
iptables -N ip-filter
iptables -A FORWARD -p icmp -j ACCEPT
iptables -A FORWARD -j ip-filter
$GETMIB ACPC_TBL > $TMP_FILE
line=`cat $TMP_FILE | wc -l`
num=1
while [ $num -le $line ];
do
ACPC_TMP=`head -n $num  $TMP_FILE | tail -n 1`
ACPC_TMP1=`echo $ACPC_TMP | cut -f2 -d=`
if [ "$ACPC_TMP1" != "" ]; then
ACPC_TMP=`echo $ACPC_TMP | cut -f2 -d=`
fi
ACPC_IP=`echo $ACPC_TMP | cut -f2 -d'|'`
ACPC_IP1=`echo $ACPC_IP | cut -f1 -d:`
ACPC_IP2=`echo $ACPC_IP | cut -f2 -d:`
ACPC_PORT=`echo $ACPC_TMP | cut -f3 -d'|'`
PORT_TMP=`echo $ACPC_PORT | cut -f2 -d,`
ACPC_PORT1=`echo $ACPC_PORT | cut -f1 -d:`
ACPC_PORT2=`echo $ACPC_PORT | cut -f2 -d:`
ACPC_PROTO=`echo $ACPC_TMP | cut -f4 -d'|'`
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
if [ "$ACPC_IP1" = "0.0.0.0" ] && [ "$ACPC_IP2" = "0.0.0.0" ]; then
if [ "$ACPC_PROTO" = "ALL" ]; then
if [ "$PORTFILTER_DENY" = "0" ]; then
iptables -A ip-filter -p TCP -m $MPORT --dports $ACPC_PORT -j DROP
iptables -A ip-filter -p UDP -m $MPORT --dports $ACPC_PORT -j DROP
else
if [ "$MACFILTER_ENABLED" = 1 ] && [ $MACFILTER_TBL_NUM -gt 0 ]; then
iptables -A ip-filter -p TCP -m $MPORT --dports $ACPC_PORT -j RETURN
iptables -A ip-filter -p UDP -m $MPORT --dports $ACPC_PORT -j RETURN
else
iptables -A ip-filter -p TCP -m $MPORT --dports $ACPC_PORT -j ACCEPT
iptables -A ip-filter -p UDP -m $MPORT --dports $ACPC_PORT -j ACCEPT
fi
fi
else
if [ "$PORTFILTER_DENY" = "0" ]; then
if [ "$ACPC_PORT" = "1863" ]; then
iptables -A FORWARD -p TCP -d 207.46.104.20 -j DROP
fi
iptables -A ip-filter -p $ACPC_PROTO -m $MPORT --dports $ACPC_PORT -j DROP
else
if [ "$MACFILTER_ENABLED" = 1 ] && [ $MACFILTER_TBL_NUM -gt 0 ]; then
iptables -A ip-filter -p $ACPC_PROTO -m $MPORT --dports $ACPC_PORT -j RETURN
else
iptables -A ip-filter -p $ACPC_PROTO -m $MPORT --dports $ACPC_PORT -j ACCEPT
fi
fi
fi
else
if [ "$ACPC_PROTO" = "ALL" ]; then
if [ "$IPDENY_ENABLED" = "1" ]; then
iptables -A ip-filter -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j DROP
iptables -A ip-filter -p UDP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j DROP
else
if [ "$MACFILTER_ENABLED" = 1 ] && [ $MACFILTER_TBL_NUM -gt 0 ]; then
iptables -A ip-filter -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j RETURN
iptables -A ip-filter -p UDP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j RETURN
else
iptables -A ip-filter -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j ACCEPT
iptables -A ip-filter -p UDP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j ACCEPT
fi
fi
else
if [ "$IPDENY_ENABLED" = "1" ]; then
if [ "$ACPC_PORT" = "1863" ]; then
iptables -A FORWARD -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -d 207.46.104.20 -j DROP
fi
iptables -A ip-filter -p $ACPC_PROTO -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j DROP
else
if [ "$MACFILTER_ENABLED" = 1 ] && [ $MACFILTER_TBL_NUM -gt 0 ]; then
iptables -A ip-filter -p $ACPC_PROTO -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j RETURN
else
iptables -A ip-filter -p $ACPC_PROTO -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j ACCEPT
fi
fi
fi
fi
else
if [ "$ACPC_PROTO" = "ALL" ]; then
if [ "$IPDENY_ENABLED" = "1" ]; then
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A ip-filter -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j DROP"
else
iptables -A ip-filter -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j DROP
fi
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A ip-filter -p UDP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j DROP"
else
iptables -A ip-filter -p UDP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j DROP
fi
else
if [ "$MACFILTER_ENABLED" = 1 ] && [ $MACFILTER_TBL_NUM -gt 0 ]; then
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A ip-filter -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j RETURN"
else
iptables -A ip-filter -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j RETURN
fi
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A ip-filter -p UDP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j RETURN"
else
iptables -A ip-filter -p UDP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j RETURN
fi
else
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A ip-filter -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j ACCEPT"
else
iptables -A ip-filter -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j ACCEPT
fi
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A ip-filter -p UDP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j ACCEPT"
else
iptables -A ip-filter -p UDP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j ACCEPT
fi
fi
fi
else
if [ "$IPDENY_ENABLED" = "1" ]; then
if [ "$ACPC_PORT" = "1863" ]; then
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A FORWARD -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -d 207.46.104.20 -j DROP"
else
iptables -A FORWARD -p TCP -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -d 207.46.104.20 -j DROP
fi
fi
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A ip-filter -p $ACPC_PROTO -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j DROP"
else
iptables -A ip-filter -p $ACPC_PROTO -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j DROP
fi
else
if [ "$MACFILTER_ENABLED" = 1 ] && [ $MACFILTER_TBL_NUM -gt 0 ]; then
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A ip-filter -p $ACPC_PROTO -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j RETURN"
else
iptables -A ip-filter -p $ACPC_PROTO -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j RETURN
fi
else
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $ACPC_IP1 1 "iptables -A ip-filter -p $ACPC_PROTO -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j ACCEPT"
else
iptables -A ip-filter -p $ACPC_PROTO -m iprange --src-range $ACPC_IP1-$ACPC_IP2 -m $MPORT --dports $ACPC_PORT -j ACCEPT
fi
fi
fi
fi
fi
num=`expr $num + 1`
done
rm -f $TMP_FILE
if [ "$IPDENY_ENABLED" = 0 ]; then
iptables -A ip-filter -i br0 -j DROP
fi
fi
if [ "$MACDENY_ENABLED" = "" ]; then
MACDENY_ENABLED=0;
fi
if [ "$MACFILTER_ENABLED" = 1 ] && [ $MACFILTER_TBL_NUM -gt 0 ]; then
num=1
while [ $num -le $MACFILTER_TBL_NUM ];
do
MACFILTER_TBL=`flash get MACFILTER_TBL | grep MACFILTER_TBL$num= | grep -v grep`
tmp_addr=`echo $MACFILTER_TBL | cut -f2 -d=`
addr=`echo $tmp_addr | cut -f1 -d,`
if [ "$MACDENY_ENABLED" = "1" ]; then
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $addr 1 "iptables -A FORWARD -m mac --mac-source $addr -j DROP"
else
iptables -A FORWARD -m mac --mac-source $addr -j DROP
fi
else
if [ "$_PC_DATABASE_" = "y" ]; then
addTime $addr 1 "iptables -A FORWARD -m mac --mac-source $addr -j ACCEPT"
else
iptables -A FORWARD -m mac --mac-source $addr -j ACCEPT
fi
fi
num=`expr $num + 1`
done
if [ "$MACDENY_ENABLED" = 0 ]; then
iptables -A FORWARD -i br0 -j DROP
fi
fi
