#!/bin/sh
if [ $# -lt 3 ]; then echo "Usage: $0 br_interface lan1_interface wlan_interface lan2_interface...";  exit 1 ; fi
. /bin/scriptlib.sh
. /web/FUNCTION_SCRIPT
GETMIB="flash get"
BR_UTIL=brctl
SET_IP=fixedip.sh
START_DHCP_CLIENT=dhcpc.sh
IFCONFIG=ifconfig
WLAN_PREFIX=wlan
LAN_PREFIX=eth
MAX_WDS_NUM=5
WLAN_IF2=wlan0-vxd
if [ "$3" != "null" ]; then
for ARG in $* ; do
INTERFACE=`echo $ARG | cut -b -4`
if [ $INTERFACE = $WLAN_PREFIX ]; then
$IFCONFIG $ARG down
if [ "$_MSSID_" = "y" ]; then
VXD=`echo $ARG | cut -b 7-`
VAP=`echo $ARG | cut -b 7-8`
if [ "$VXD" != "vxd" ] && [ "$VAP" != "va" ]; then
num=0
while [ $num -lt $MAX_WDS_NUM ]
do
$IFCONFIG $ARG-wds$num down
num=`expr $num + 1`
$BR_UTIL delif $1 $ARG-wds$num 2> /dev/null
done
fi
if [ "$VAP" = "va" ]; then
$BR_UTIL delif $1 $ARG 2> /dev/null
fi
fi  #endof MSSID=y
else
$IFCONFIG $ARG down
if [ $ARG != $1 ]; then
$BR_UTIL delif $1 $ARG 2> /dev/null
fi
fi
done
$BR_UTIL delif $1 eth1 2> /dev/null
$BR_UTIL delif $1 wlan0 2> /dev/null
$IFCONFIG $1 down
$BR_UTIL delbr $1
if  [ "$REPEATER_ENABLED" != 0 ] ;then
ifconfig $WLAN_IF2 down
fi
echo 'Setup bridge...'
$BR_UTIL addbr $1
if [ "$STP_ENABLED" = '0' ]; then
$BR_UTIL setfd $1 0
$BR_UTIL stp $1 0
else
$BR_UTIL setfd $1 4
$BR_UTIL stp $1 1
fi
if [ "$_KERNEL_VERSION_26_" = "y" ]; then
if [ ! -f /tmp/rtk_vlan_support ]; then
if [ "$_DMZ_BY_PORT_" ]; then
echo 1 > /proc/rtk_vlan_support
portmask=1
i=1
while [ "$i" -lt "$_DMZ_BY_PORT_" ]; do
portmask=`expr $portmask \* 2`
i=`expr $i + 1`
done
echo "0 0 0 0 0 0 0 $portmask 1" > /proc/eth2/mib_vlan
echo "0 0 0 0 0 0 0 `expr 15 - $portmask` 3" > /proc/eth0/mib_vlan
else
echo 0 > /proc/rtk_vlan_support
fi
echo 1 > /tmp/rtk_vlan_support
fi
else
if [ "$_DMZ_BY_PORT_" -a "$DMZ_BY_PORT_ENABLE" == "1" ]; then
echo 1 > /proc/disable_l2_table
fi
fi
if [ "$_VLAN_CONFIG_SUPPORTED_" = "y" ]; then
eval `$GETMIB VLANCONFIG_ENABLED`
if [ $VLANCONFIG_ENABLED != 0 ]; then
echo 1 > /proc/disable_l2_table
else
echo 0 > /proc/disable_l2_table
fi
ETH_VLAN_SWITCH=/proc/disable_l2_table
if [ -f $ETH_VLAN_SWITCH ]; then
eval `$GETMIB VLANCONFIG_TBL_NUM`
num=1
while [ $num -le $VLANCONFIG_TBL_NUM ];
do
VLANCONFIG_TBL=`flash get VLANCONFIG_TBL | grep VLANCONFIG_TBL$num=`
tmp_str=`echo $VLANCONFIG_TBL | cut -f2 -d=`
name=`echo $tmp_str | cut -f1 -d,`
vlan=`echo $tmp_str | cut -f2 -d,`
tag=`echo $tmp_str | cut -f3 -d,`
priority=`echo $tmp_str | cut -f4 -d,`
cfi=`echo $tmp_str | cut -f5 -d,`
vid=`echo $tmp_str | cut -f6 -d,`
is_lan=`echo $tmp_str | cut -f7 -d,`
DRV_VLAN_FILE=/proc/$name/mib_vlan
if [ -f $DRV_VLAN_FILE ]; then
if [ $VLANCONFIG_ENABLED != 0 ]; then
echo "1 $is_lan $vlan $tag $vid $priority $cfi" > $DRV_VLAN_FILE
else
echo "0 $is_lan $vlan $tag $vid $priority $cfi" > $DRV_VLAN_FILE
fi
fi
num=`expr $num + 1`
done
if [ $VLANCONFIG_ENABLED != 0 ]; then
echo 1 > /proc/disable_l2_table
else
echo 0 > /proc/disable_l2_table
fi
fi
fi #end _VLAN_CONFIG_SUPPORTED_=y
for ARG in $* ; do
INTERFACE=`echo $ARG | cut -b -3`
if [ $INTERFACE = $LAN_PREFIX ]; then
up_interface=1
if [ "$_VLAN_CONFIG_SUPPORTED_" = "y" ]; then
if [ -f $ETH_VLAN_SWITCH ]; then
eth_num=`echo $ARG | cut -b 4-4`
if [ $VLANCONFIG_ENABLED = 0 ] && [ $eth_num -ge 2 -a $eth_num -le 4 ]; then
up_interface=0
fi
fi
fi
if [ $up_interface != 0 ]; then
$BR_UTIL addif $1 $ARG 2> /dev/null
$SET_IP $ARG  0.0.0.0
fi
fi
done
for ARG in $* ; do
INTERFACE=`echo $ARG | cut -b -4`
VAP_PRE=`echo $ARG | cut -b -8`
if [ $INTERFACE = $WLAN_PREFIX ]; then
if [ "$WLAN_DISABLED" = 0 ] && [ "$VAP_PRE" != "wlan0-va" ]; then
if [ "$OP_MODE" = '0' ] || [ $ARG != "wlan$WISP_WAN_ID" ] ;then
$BR_UTIL addif $1 $ARG
$SET_IP $ARG 0.0.0.0
else
$IFCONFIG $ARG up
fi
if [ $AP_MODE = '3' -o $AP_MODE = '4' -o $AP_MODE = '5' ]; then
num=0
addr_num=1
while [ $addr_num -le 4 ]
do
eval "WL_LINKMAC="\$WL_LINKMAC$addr_num""
if [ "$WL_LINKMAC" != "000000000000" ]; then
$BR_UTIL addif $1 wlan0-wds$num
$SET_IP wlan0-wds$num 0.0.0.0
num=`expr $num + 1`
fi
if [ $AP_MODE = '3' ]; then
addr_num=`expr $addr_num + 4`
else
addr_num=`expr $addr_num + 1`
fi
done
fi
fi
if [ "$_MSSID_" = "y" ]; then
if [ "$VAP_PRE" = "wlan0-va" ]; then
VAPNUMB=`echo $ARG | cut -b 9-9`
VAPNUMB=`expr $VAPNUMB + 1`
VAPEN=`$GETMIB SSID_MIRROR_$VAPNUMB`
VAPEN1=`echo $VAPEN | cut -b 15-15`
if [ "$VAP_PRE" = "wlan0-va" ] && [ "$VAPEN1" -gt 0 ]; then
$BR_UTIL addif $1 $ARG	2> /dev/null
$SET_IP $ARG 0.0.0.0
fi
fi
fi
fi
done
if  [ "$REPEATER_ENABLED" != 0 ] ;then
if [ "$WLAN_MAC_ADDR" = "000000000000" ]; then
WLAN_MAC_ADDR=$HW_WLAN_ADDR
fi
ifconfig $WLAN_IF2 hw ether $WLAN_MAC_ADDR
ifconfig $WLAN_IF2 up
brctl addif br0 $WLAN_IF2
fi
if  [ "$OP_MODE" = "1" ] ;then
ifconfig $WLAN_IF2 up
if [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258GNL" ]; then
brctl addif br0 wlan0	
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258NL" ]; then	
brctl addif br0 wlan0
else
brctl addif br0 $WLAN_IF2
fi
fi
$SET_IP $1 0.0.0.0
fi
eval `$GETMIB DHCP`
if [ "$DHCP" = '0' -o "$DHCP" = '2' ]; then
$SET_IP $1 $IP_ADDR $SUBNET_MASK $DEFAULT_GATEWAY
elif [ "$DHCP" = '1' ]; then
{
eval `$GETMIB STP_ENABLED`
if [ "$STP_ENABLED" = '1' ]; then
echo 'waiting for bridge initialization...'
sleep 30
fi
$START_DHCP_CLIENT $1 no
}&
fi
