#!/bin/sh
if [ $# -lt 1 ]; then echo "Usage: $0 interface";  exit 1 ; fi
. /bin/scriptlib.sh
CONF_FILE=/var/udhcpd.conf
LEASE_FILE=/var/lib/misc/udhcpd.leases
if [ "$_MODE_" != "Customer" -o "$_MODE_" != "Customer" ] && [ "$DHCP" != '2' ]; then
exit 0
fi
echo "interface $1" > $CONF_FILE
echo "start $DHCP_CLIENT_START" >> $CONF_FILE
echo "end $DHCP_CLIENT_END" >> $CONF_FILE
echo "opt subnet $SUBNET_MASK" >> $CONF_FILE
if [ "$_WanAutoDetect_" = "y" ]; then
echo "opt domain Customer.com" >> $CONF_FILE
fi
if [ "$_QUICK_MODE_TYPE_" = "y" ]; then
echo "opt domain general.com" >> $CONF_FILE
fi
if [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258NL" ]; then
echo "opt domain Customer.com" >> $CONF_FILE
fi
if [ "$_MODE_" = "Customer" ];then
echo "opt domain Customer.com" >> $CONF_FILE
fi
if [ "$_MODE_" = "Customer" ]; then
echo "opt domain airlink" >> $CONF_FILE
fi
if [ "$_MODE_" = "Customer" -a "$_MODEL_" = "BR6228GNS" ]; then #EDX Brian
echo "opt domain intellinet" >> $CONF_FILE
fi
if [ "$_DHCP_SERVER_WITH_GW_DNS_" = "y" ] && [ "$DHCP_SERVER_GW" != "0.0.0.0" ]; then
echo "opt router $DHCP_SERVER_GW"  >> $CONF_FILE
else
if [ "$_IS_GATEWAY_" = "y" ]; then		
echo "opt router $IP_ADDR"  >> $CONF_FILE
else
echo "opt router $DHCPGATEWAYIP_ADDR"  >> $CONF_FILE
fi
fi
if [ "$_IS_GATEWAY_" = "y" ]; then		
if [ "$_DHCP_SERVER_WITH_GW_DNS_" = "y" ]; then
if [ "$DHCP_SERVER_DNS1" != "0.0.0.0" ] || [ "$DHCP_SERVER_DNS2" != "0.0.0.0" ]; then
if [ "$DHCP_SERVER_DNS1" != "0.0.0.0" ]; then
echo "opt dns $DHCP_SERVER_DNS1" >> $CONF_FILE
fi
if [ "$DHCP_SERVER_DNS2" != "0.0.0.0" ]; then
echo "opt dns $DHCP_SERVER_DNS2" >> $CONF_FILE
fi
else
echo "opt dns $IP_ADDR" >> $CONF_FILE
fi
elif [ "$_MODEL_" = "BR6428GN" ] && [ "$_MODE_" = "Customer" ] && [ "$DNS1" != '0.0.0.0' -o "$DNS2" != '0.0.0.0' -o "$DNS3" != '0.0.0.0' ]; then
if [ "$DNS1" != '0.0.0.0' ]; then echo "opt dns ${DNS1}" >> $CONF_FILE; fi
if [ "$DNS2" != '0.0.0.0' ]; then echo "opt dns ${DNS2}" >> $CONF_FILE; fi
if [ "$DNS3" != '0.0.0.0' ]; then echo "opt dns ${DNS3}" >> $CONF_FILE; fi
else
if [ "$_EZVIEW_" != "y" ]; then
if [ "$DNS_MODE" = '0' ]; then
echo "opt dns $IP_ADDR" >> $CONF_FILE
else
if [ "$_PPTP_FQDN_" = "y" ] && [ "$WAN_MODE" = "3" -o "$WAN_MODE" = "6" ]; then
echo "opt dns $IP_ADDR" >> $CONF_FILE
elif [ "$_WanAutoDetect_" = "y" ];then
echo "opt dns $IP_ADDR" >> $CONF_FILE
else
if [ "$DNS1" != "0.0.0.0" ]; then
echo "opt dns $DNS1" >> $CONF_FILE
fi
if [ "$DNS2" != "0.0.0.0" ]; then
echo "opt dns $DNS2" >> $CONF_FILE
fi
if [ "$DNS3" != "0.0.0.0" ]; then
echo "opt dns $DNS3" >> $CONF_FILE
fi
if [ "$DNS1" = "0.0.0.0" ] && [ "$DNS2" = "0.0.0.0" ] && [ "$DNS3" = "0.0.0.0" ]; then
echo "opt dns $IP_ADDR" >> $CONF_FILE
fi
fi
fi
else
if [ "$DNS_MODE" = '1' ]; then	
echo "opt dns $DNS1" >> $CONF_FILE
else
echo "opt dns $IP_ADDR" >> $CONF_FILE
fi
fi
fi
fi
if [ "$DOMAIN_NAME" ]; then
echo "option domain $DOMAIN_NAME" >> $CONF_FILE
fi
if [ "$_SDMZ_" = "y" ]; then
if [ "$DMZ_ENABLED" = "1" ] && [ "$DMZ_MODE" = "1" ] && [ "$DMZ_MAC_ADDR" != "000000000000" ]; then
SDMZ_START=`cat /proc/sys/net/ipv4/super_dmz_control| cut -f1 -d " "`
if [ "$SDMZ_START" = "000000000000" ]; then
echo "option lease 20" >> $CONF_FILE
else
echo "option lease $LAN_LEASE_TIME" >> $CONF_FILE
fi
else
echo "option lease $LAN_LEASE_TIME" >> $CONF_FILE
fi
else
echo "option lease $LAN_LEASE_TIME" >> $CONF_FILE
fi
if [ "$_IS_GATEWAY_" = "y" ]; then		
if [ "$SDHCP_ENABLED" = "0" ]; then
echo "Static DHCP Leases disable!"
fi
if [ "$SDHCP_TBL_NUM" -gt "0" ] && [ "$SDHCP_ENABLED" -gt "0" ]; then
echo "SDHCP_NUM=$SDHCP_TBL_NUM"
num=1
while [ "$num" -le "$SDHCP_TBL_NUM" ];
do
eval "static_lease="\$SDHCP_TBL$num""
sdhcp_mac=`echo $static_lease | cut -f1 -d,`
sdhcp_ip=`echo $static_lease | cut -f2 -d,`
echo "static_lease $sdhcp_mac $sdhcp_ip" >> $CONF_FILE
num=`expr $num + 1`
done
fi
PIDFILE=/etc/udhcpc/udhcpc-$BR_INTERFACE.pid
if [ -f $PIDFILE ] ; then
PID=`cat $PIDFILE`
if [ "$PID" != "0" ]; then
kill -9 $PID 2> /dev/null
fi
rm -f $PIDFILE 2> /dev/null
fi
else
echo "opt dns $DHCPNAMESERVER_ADDR" >> $CONF_FILE
fi
if [ "$_DHCP_LEASEFILE_NO_REMOVE_" != "y" ]; then
if [ -f "$LEASE_FILE" ]; then
rm -f $LEASE_FILE 2> /dev/null
fi
echo "" > $LEASE_FILE
fi
if [ "$_IS_GATEWAY_" = "y" ]; then
fixedip.sh $1 $IP_ADDR $SUBNET_MASK 0.0.0.0
fi
ifconfig eth0 down
ifconfig eth1 down
sleep 1
ifconfig eth0 up
ifconfig eth1 up
udhcpd $CONF_FILE
