#!/bin/sh
. /bin/scriptlib.sh
LINKFILE=/etc/ppp/link0
LINKFILE1=/etc/ppp/link1
LINKFILE2=/etc/ppp/link2
PPPFILE=/var/run/ppp0.pid
PPPFILE1=/var/run/ppp1.pid
PPPFILE2=/var/run/ppp2.pid
WAN_INTERFACE=$_WAN_IF_			# Rex, Fixed me, this should be same as init.sh
. /web/FUNCTION_SCRIPT
killall dhid 2>/dev/null
killall upnpd 2>/dev/null
killall mini_upnpd 2>/dev/null
killall dnrd 2>/dev/null
if [ "$_NATPMP_" = "y" ]; then
killall -9 natpmp  2>/dev/null
fi
if [ "$_WPS_Daemon_" != "" ]; then
kill -9 `pidof wps_daemon.sh`
fi
if [ "$_DMZ_BY_PORT_" != "" ]; then
kill -9 `pidof dmz_by_port.sh`
fi
if [ "$_IGMP_PROXY_" = "y" ]; then
killall -9 igmpproxy 2>/dev/null
fi
if [ "$_PPTP_PASSSTHROUGH_" = "y" ]; then
rmmod nf_nat_pptp 2>/dev/null
rmmod nf_nat_proto_gre 2>/dev/null
rmmod nf_conntrack_pptp 2>/dev/null
rmmod nf_conntrack_proto_gre 2>/dev/null
fi
if [ -f /tmp/old_mode ]; then
OLD_MODE=`cat /tmp/old_mode`
case "$OLD_MODE" in
"0")
echo "old mode is DHCP"
killall udhcpc 2>/dev/null
killall rdisc 2>/dev/null
rm /etc/resolv.conf 2>/dev/null
;;
"1")
echo "old mode is static IP"
rm /etc/resolv.conf 2>/dev/null
;;
"2")
echo "old mode is PPPoE"
echo "arg1=$1 arg2=$2 arg3=$3"
if [ "$1" = "all" ] || [ "$1" != "pppoe" ]; then
if [ "$1" != "option" ]; then			# disconnect.sh option will call by pppd
killall pppoe.sh 2>/dev/null
killall pppoeloop.sh 2>/dev/null
if [ "$_MPPPOE_" = "y" ]; then
for i in `pidof pppd`
do
kill -15 $i 2>/dev/null
sleep 1
done
rm /etc/resolv* 2>/dev/null
rm /etc/ppp/resolv* 2>/dev/null
else			
killall  pppd 2>/dev/null
rm /etc/resolv.conf 2>/dev/null
rm /etc/ppp/resolv.conf 2>/dev/null
fi
fi
echo "delete all resolv files"
fi
if [ "$3" = "all" ]; then
kill -15 `pidof pppoeloop.sh $2`
fi		
if [ "$_TRIPPPOE_" != "y" ] & [ "$_MPPPOE_" != "y" ]; then
echo "killall pppd"
killall   pppd 2>/dev/null
fi
if [ "$1" = "pppoe" ] || [ "$1" = "option" ]; then
if [ "$2" = "0" ]; then
pid0=`ps | grep -i "pppd 0" | grep -v grep | cut -b1-6 | tr -d " "`
if [ "$pid0" != "" ]; then
kill -15 $pid0
rm /etc/ppp/resolv.conf 2>/dev/null
rm /etc/resolv.conf 2>/dev/null				
fi
elif [ "$2" = "1" ]; then
pid1=`ps | grep -i "pppd 1" | grep -v grep | cut -b1-6 | tr -d " "`
if [ "$pid1" != "" ]; then
kill -15 $pid1
rm /etc/ppp/resolv1.conf 2>/dev/null
rm /etc/resolv1.conf 2>/dev/null
fi
elif [ "$2" = "2" ]; then
pid2=`ps | grep -i "pppd 2" | grep -v grep | cut -b1-6 | tr -d " "`
if [ "$pid2" != "" ]; then
kill -15 $pid2
rm /etc/ppp/resolv2.conf 2>/dev/null
rm /etc/resolv2.conf 2>/dev/null
fi
else
killall pppd 2>/dev/null
fi
if [ "$PPP_CONNECT_TYPE" = "1" ]; then
killall iapp 2>/dev/null
killall wscd 2>/dev/null
killall iwcontrol 2>/dev/null
iapp br0 wlan0 &				
wscd -start -c /var/wsc.conf -w wlan0 -fi /var/wscd-wlan0.fifo &
iwcontrol wlan0	&		
fi			
fi
;;
"3")
echo "old mode is PPTP "
echo "arg1=$1 arg2=$2 arg3=$3"
if [ "$1" = "all" ] || [ "$1" != "pptp" ]; then
if [ "$1" != "option" ]; then
killall pptp.sh 2>/dev/null
fi
fi
killall udhcpc 2>/dev/null
killall rdisc 2>/dev/null
killall pptp 2>/dev/null
killall  pppd 2>/dev/null
rm /etc/ppp/resolv.conf 2>/dev/null
rm /etc/resolv.conf 2>/dev/null
if [ "$PPTP_CONNECT_TYPE" = "1" ]; then
killall iapp 2>/dev/null
killall wscd 2>/dev/null
killall iwcontrol 2>/dev/null
iapp br0 wlan0 &			
wscd -start -c /var/wsc.conf -w wlan0 -fi /var/wscd-wlan0.fifo &
iwcontrol wlan0	&	
fi		
;;
"4")
echo "old mode is BigBond"
killall udhcpc 2>/dev/null
killall bpalogin 2>/dev/null
killall rdisc 2>/dev/null
;;
"6")
echo "old mode is L2TP"
echo "arg1=$1 arg2=$2 arg3=$3"
if [ "$1" = "all" ] || [ "$1" != "l2tp" ]; then
if [ "$1" != "option" ]; then
if [ "$_L2TPD_" != "" ]; then
kill -9 `ps | grep l2tp_2.sh | grep -v grep | cut -b 1-5`
else
killall l2tp.sh 2>/dev/null
fi
fi
fi
if [ "$_L2TPD_" != "" ]; then
echo "d client" > /var/run/l2tp-control
killall l2tpd
else
/bin/handlers/l2tp-control "exit"
fi
sleep 1
killall  pppd 2>/dev/null
killall udhcpc 2>/dev/null
killall rdisc 2>/dev/null
rm /etc/ppp/resolv.conf 2>/dev/null
rm /etc/resolv.conf 2>/dev/null
;;
esac
fi
if [ "$1" = "all" ]; then
sleep 2
rm /var/run/dns-tmp 2>/dev/null
fi
if [ "$_WAN_IF_" != "" ]; then
ifconfig $_WAN_IF_ 0.0.0.0 2>/dev/null
echo "Close Wan Interface!!"
if [ "$_Customer30_" = "y" ]; then
./bin/ddns_update&				#jeremy 100720 added
fi
if [ "$_INTERNET_STATE_" = "y" ]; then
echo 1 > /proc/internet_led
fi
fi
if [ "$1" = "option" ]; then
if [ "$2" = "0" ]; then
if [ -r "$LINKFILE" ]; then
rm $LINKFILE 2>/dev/null
echo delete $LINKFILE
fi
if [ -r "$PPPFILE" ]; then
rm $PPPFILE 2>/dev/null
echo delete $PPPFILE
fi
fi
if [ "$2" = "1" ]; then
if [ -r "$LINKFILE1" ]; then
rm $LINKFILE1 2>/dev/null
echo delete $LINKFILE1
fi
if [ -r "$PPPFILE1" ]; then
rm $PPPFILE1 2>/dev/null
echo delete $PPPFILE1
fi
fi
if [ "$2" = "2" ]; then
if [ -r "$LINKFILE2" ]; then
rm $LINKFILE2 2>/dev/null
echo delete $LINKFILE2
fi
if [ -r "$PPPFILE2" ]; then
rm $PPPFILE2 2>/dev/null
echo delete $PPPFILE2
fi
fi
fi
if [ -r "$LINKFILE" ]; then
if  [ "$1" = "pppoe" -a "$2" = "1" ]; then
echo ""
else
if  [ "$2" = "0" ]; then
rm $LINKFILE 2>/dev/null
fi	
fi
fi
if [ -r "$PPPFILE" ]; then
if  [ "$1" = "pppoe" -a "$2" = "1" ]; then
echo ""
else
if  [ "$2" = "0" ]; then	
rm $PPPFILE 2>/dev/null
fi
fi
fi
if [ -r "$LINKFILE1" ]; then
if  [ "$1" = "pppoe" -a "$2" = "0" ]; then
echo ""
else
if  [ "$2" = "1" ]; then
rm $LINKFILE1 2>/dev/null
fi
fi
fi
if [ -r "$PPPFILE1" ]; then
if  [ "$1" = "pppoe" -a "$2" = "0" ]; then
echo ""
else
if  [ "$2" = "1" ]; then
rm $PPPFILE1 2>/dev/null
fi
fi
fi
if [ -r "$LINKFILE2" ]; then
if  [ "$1" = "pppoe" -a "$2" = "0" ]; then
echo ""
else
if  [ "$2" = "2" ]; then
rm $LINKFILE2 2>/dev/null
fi
fi
fi
if [ -r "$PPPFILE2" ]; then
if  [ "$1" = "pppoe" -a "$2" = "0" ]; then
echo ""
else
if  [ "$2" = "2" ]; then
rm $PPPFILE2 2>/dev/null
fi
fi
fi
rm jj1 2>/dev/null
rm jj2 2>/dev/null
if [ "$_MPPPOE_" = "y" ] || [ "$_TRIPPPOE_" = "y" ]; then
dnrd -k &
sleep 2
if [ "`pidof dnrd`" = "" -a "$DNS_MODE" = 0 ]; then
/bin/dnrd.sh
fi
if [ "$_KERNEL_VERSION_26_" = "y" ]; then
iptables -P INPUT ACCEPT
fi
else
iptables -F
iptables -F -t nat
if [ "$_WanAutoDetect_" = "y" ]; then
AUTODETECT_DISABLE="`flash get AUTODETECT_DISABLE | cut -d '=' -f 2`"
if [ "$AUTODETECT_DISABLE" = 0 ]; then
ppp_connect_type="`flash get PPP_CONNECT_TYPE | cut -d '=' -f 2`"
pptp_connect_type="`flash get PPTP_CONNECT_TYPE | cut -d '=' -f 2`"
l2tp_connect_type="`flash get L2TP_CONNECT_TYPE | cut -d '=' -f 2`"
if [ "$ppp_connect_type" = 0 ] && [ "$pptp_connect_type" = 0 ] && [ "$l2tp_connect_type" = 0 ]; then
if [ "$1" = "all" -a "$2" = "0" ]; then
echo ""
else
dnrd -k 2>/dev/null
dnrd.sh
/tmp/iptables_build.sh
fi
fi
fi
fi
if [ "$_KERNEL_VERSION_26_" = "y" ]; then
iptables -P INPUT ACCEPT
fi
fi
