#!/bin/sh
echo --------------------------------------------------------------------------------
echo $0 $*
echo --------------------------------------------------------------------------------
. /var/flash.inc
if [ "$INET_SCH_ENABLED" = 1 ] && [ $INET_SCH_NUM -gt 0 ]; then
iptables -N INET_SCH
i=1
if [ "$INET_SCH_ALLOW" = 1 ]; then
command="DROP"
else
command="RETURN"
fi
eval "inet_sch=\$INET_SCH$i"
while [ $i -le $INET_SCH_NUM ]; do
time_start="`echo $inet_sch | cut -d \" \" -f 1`"
time_stop="`echo $inet_sch | cut -d \" \" -f 2`"
week_days="`echo $inet_sch | cut -d \" \" -f 3`"
subnetwork="`echo $inet_sch | cut -d \" \" -f 4`"
if [ "`iptables -V | grep 1.4`" ]; then # iptables 1.4.x+
if [ "$subnetwork" = "" ]; then
iptables -A INET_SCH -m time --timestart $time_start --timestop $time_stop --weekdays $week_days -j $command
else
iptables -A INET_SCH -s $subnetwork -m time --timestart $time_start --timestop $time_stop --weekdays $week_days -j $command
fi
else
if [ "$subnetwork" = "" ]; then
iptables -A INET_SCH -m time --timestart $time_start --timestop $time_stop --days $week_days -j $command
else
iptables -A INET_SCH -s $subnetwork -m time --timestart $time_start --timestop $time_stop --days $week_days -j $command
fi
fi
i=`expr $i + 1`
eval "inet_sch=\$INET_SCH$i"
done
if [ "$INET_SCH_ALLOW" = 0 ]; then
iptables -A INET_SCH -j DROP
fi
iptables -A FORWARD -i br0 -j INET_SCH
fi