#!/bin/sh
. /web/FUNCTION_SCRIPT
eval `flash get UPNP_ENABLE`
eval `flash get OP_MODE`
eval `flash get WAN_MODE`
eval `flash get HW_NIC0_ADDR`
if [ -f /tmp/pppid ]; then
. /tmp/pppid
fi
echo "-----> Starting miniupnpd"
iptables -t nat -F MINIUPNPD 2> /dev/null
iptables -t nat -X MINIUPNPD 2> /dev/null
iptables -t filter -F MINIUPNPD 2> /dev/null
iptables -t filter -X MINIUPNPD 2> /dev/null
PIDFILE=/var/run/miniupnpd.pid
if [ -f $PIDFILE ] ; then
PID=`cat $PIDFILE`
if [ "$PID" != "0" ]; then
kill -9 $PID 2> /dev/null
fi
rm -f $PIDFILE 2> /dev/null
fi
if [ "$1" = "disable" ]; then
UPNP_ENABLE=0
fi
if [ "$UPNP_ENABLE" = "0" ]; then
echo "UPNP disabled!"
route del -net 239.0.0.0 netmask 255.0.0.0 br0
else
route del -net 239.0.0.0 netmask 255.0.0.0 br0
WAN=eth1
if [ "$OP_MODE" = "1" ];then
WAN=br1
fi
if [ "$OP_MODE" = "2" ];then
WAN=wlan$WISP_WAN_ID
fi
if [ "$WAN_MODE" = "2" ]; then
if [ -f /tmp/pppid ]; then
WAN=$PPP_ID
else
WAN=ppp0
fi
fi
if [ "$WAN_MODE" = "3" ]; then
if [ -f /tmp/pppid ]; then
WAN=$PPP_ID
else
WAN=ppp0
fi
fi
if [ "$WAN_MODE" = "6" ]; then
if [ -f /tmp/pppid ]; then
WAN=$PPP_ID
else
WAN=ppp0
fi
fi
if [ "$WAN_MODE" = "9" ]; then
WAN=ra0
fi
route add -net 239.0.0.0 netmask 255.0.0.0 br0
EXT_IP0=`ifconfig $WAN | grep -i "addr:"`
EXT_IP1=`echo $EXT_IP0 | cut -f2 -d:`
EXT_IP=`echo $EXT_IP1 | cut -f1 -d " "` # WAN IP
echo "External IP = $EXT_IP"
INT_IP0=`ifconfig $BRIDGE | grep -i "addr:"`
INT_IP1=`echo $INT_IP0 | cut -f2 -d:`
INT_IP=`echo $INT_IP1 | cut -f1 -d " "` # LAN IP
echo "Internal IP = $INT_IP"
iptables -t nat -N MINIUPNPD
iptables -t nat -A PREROUTING -d $EXT_IP -i $WAN -j MINIUPNPD
iptables -t filter -N MINIUPNPD
iptables -t filter -A FORWARD -i $WAN -o ! $WAN -j MINIUPNPD
if [ "$_UPNP_WSCD_INDEPEND_" = "y" ]; then
killall wscd  1>/dev/null 2>&1
killall -9 wscd  1>/dev/null 2>&1
killall miniupnpd  1>/dev/null 2>&1
killall -9 miniupnpd  1>/dev/null 2>&1
sleep 3
fi
/bin/miniupnpd -i $WAN -a $INT_IP -p 5000 -u 75802409-bccb-40e7-8e6c-$HW_NIC0_ADDR &
sleep 3
fi
