#!/bin/sh
. /bin/scriptlib.sh
OPTIONS0=/etc/ppp/options0
OPTIONS1=/etc/ppp/options1
OPTIONS2=/etc/ppp/options2
PAPFILE0=/etc/ppp/pap-secrets0
PAPFILE1=/etc/ppp/pap-secrets1
PAPFILE2=/etc/ppp/pap-secrets2
CHAPFILE0=/etc/ppp/chap-secrets0
CHAPFILE1=/etc/ppp/chap-secrets1
CHAPFILE2=/etc/ppp/chap-secrets2
FIRSTFILE0=/etc/ppp/first0
FIRSTFILE1=/etc/ppp/first1
FIRSTFILE2=/etc/ppp/first2
PID_FILE=/var/run/ppp0.pid
PID_FILE1=/var/run/ppp1.pid
PID_FILE2=/var/run/ppp2.pid
if [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258GNL" ]; then
WLAN_IF2=wlan0-vxd
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258NL" ]; then
WLAN_IF2=wlan0-vxd
else
WLAN_IF2=wlan0
fi
umask 066
if [ "$OP_MODE" = "1" ];then
WAN=$WLAN_IF2
WAN2=$WLAN_IF2
else
WAN=$_WAN_IF_
WAN2=$_WAN_IF_
fi
if [ "$_MODE_" = "Customer" -o  "$_MODE_" = "Customer" ]; then
DHCP_MTU1=$DHCP_MTU
DHCP_MTU2=$DHCP_MTU
fi
if [ "$_INDEPEND_DHCP_MTU_" = "y" ]; then
MTU=`expr $DHCP_MTU + 8`
if [ "$_MPPPOE_" = "y" ]; then
MTU1=`expr $DHCP_MTU1 + 8`
MTU2=`expr $DHCP_MTU2 + 8`
fi
else	
MTU=`expr $PPP_MTU + 8`
if [ "$_MPPPOE_" = "y" ]; then
MTU1=`expr $PPP_MTU1 + 8`
MTU2=`expr $PPP_MTU2 + 8`
fi
fi
if [ "$1" = "connect" ]; then
eval ENABLE_CONNECT$2=1
else
eval ENABLE_CONNECT$2=0
fi
if [ "$_MODE_" = "Customer" ]; then
PPP_CONNECT_TYPE=`flash get PPP_CONNECT_TYPE | cut -f 2 -d =`
fi
if [ -n "$PPP_USER_NAME" ] ; then
create_pppoe_optionfile "$PPP_USER_NAME" "$PPP_MTU" "$MTU" "unit 0" "$OPTIONS0"
create_pppoe_optionfile add "defaultroute" "$OPTIONS0"
create_pppoe_secretfile "$PPP_USER_NAME" "$PPP_PASSWORD" "$PAPFILE0"
create_pppoe_secretfile "$PPP_USER_NAME" "$PPP_PASSWORD" "$CHAPFILE0"
fi
if [ -n "$PPP_USER_NAME1" ] && [ "$_MPPPOE_" = "y" ]; then
create_pppoe_optionfile "$PPP_USER_NAME1" "$PPP_MTU1" "$MTU1" "unit 1" "$OPTIONS1"
create_pppoe_optionfile add "nodefaultroute" "$OPTIONS1"
create_pppoe_secretfile "$PPP_USER_NAME1" "$PPP_PASSWORD1" "$PAPFILE1"	
create_pppoe_secretfile "$PPP_USER_NAME1" "$PPP_PASSWORD1" "$CHAPFILE1"
fi
if [ -n "$PPP_USER_NAME2" ] && [ "$_TRIPPPOE_" = "y" ]; then
create_pppoe_optionfile "$PPP_USER_NAME2" "$PPP_MTU2" "$MTU2" "unit 2" "$OPTIONS2"
create_pppoe_optionfile add "nodefaultroute" "$OPTIONS2"
create_pppoe_secretfile "$PPP_USER_NAME2" "$PPP_PASSWORD2" "$PAPFILE2"	
create_pppoe_secretfile "$PPP_USER_NAME2" "$PPP_PASSWORD2" "$CHAPFILE2"
fi
if [ "$PPP_SERVNAME" != "" ]; then
create_pppoe_optionfile add "plugin /etc/ppp/plugins/libplugin.a rp_pppoe_service $PPP_SERVNAME $WAN" "$OPTIONS0"
else
create_pppoe_optionfile add "plugin /etc/ppp/plugins/libplugin.a $WAN" "$OPTIONS0"
fi
if [ "$PPP_SERVNAME1" != "" ] && [ "$_MPPPOE_" = "y" ]; then
create_pppoe_optionfile add "plugin /etc/ppp/plugins/libplugin.a rp_pppoe_service $PPP_SERVNAME1 $WAN" "$OPTIONS1"
else
create_pppoe_optionfile add "plugin /etc/ppp/plugins/libplugin.a $WAN" "$OPTIONS1"
fi
if [ "$PPP_SERVNAME2" != "" ] && [ "$_TRIPPPOE_" = "y" ]; then
create_pppoe_optionfile add "plugin /etc/ppp/plugins/libplugin.a rp_pppoe_service $PPP_SERVNAME2 $WAN" "$OPTIONS2"
else
create_pppoe_optionfile add "plugin /etc/ppp/plugins/libplugin.a $WAN" "$OPTIONS2"
fi
if [ "$1" = "all" ]; then
/bin/disconnect.sh pppoe
fi
if [ "$PPP_CONNECT_TYPE" = "1" ]; then
echo "demand" >> $OPTIONS0
echo "idle $PPP_IDLE_TIME" >> $OPTIONS0
echo "active-filter 'outbound and (udp or tcp[13] & 4 = 0 or icmp[0]=8 or icmp[0]=13 or icmp[0]=15)'" >> $OPTIONS0
else
echo "persist" >> $OPTIONS0
fi
if [ "$PPP_CONNECT_TYPE1" = "1" ] && [ "$_MPPPOE_" = "y" ]; then
echo "demand" >> $OPTIONS1
echo "idle $PPP_IDLE_TIME1" >> $OPTIONS1
echo "active-filter 'outbound and (udp or tcp[13] & 4 = 0 or icmp[0]=8 or icmp[0]=13 or icmp[0]=15)'" >> $OPTIONS1
else
echo "persist" >> $OPTIONS1  
fi
if [ "$PPP_CONNECT_TYPE2" = "1" ] && [ "$_TRIPPPOE_" = "y" ]; then
echo "demand" >> $OPTIONS2
echo "idle $PPP_IDLE_TIME2" >> $OPTIONS2
echo "active-filter 'outbound and (udp or tcp[13] & 4 = 0 or icmp[0]=8 or icmp[0]=13 or icmp[0]=15)'" >> $OPTIONS2
else
echo "persist" >> $OPTIONS2  
fi
if [ "$PPPoEMODE" = "1" -o "$PPPoEMODE" = "2" ]; then
if [ "$PPP_UNNUMIP" != "0.0.0.0" ]; then
ifconfig br0:1 $PPP_UNNUMIP netmask $PPP_UNNUMMASK
fi
if [ "$PPP_UNNUMIP2" != "0.0.0.0" ]; then
ifconfig br0:2 $PPP_UNNUMIP2 netmask $PPP_UNNUMMASK2
fi
fi	
if [ "$PPP_CONNECT_TYPE" != "2" ]; then
/bin/scriptlib_util.sh lockusingfile
if [ ! -f $FIRSTFILE0 ]; then
echo "pass" >> $FIRSTFILE0
pppoeloop.sh "0" "$PPP_CONNECT_TYPE" "$PID_FILE" &	
fi
/bin/scriptlib_util.sh unlockfile 20
fi
if [ "$PPP_CONNECT_TYPE1" != "2" ] && [ "$PPPoEMODE" = "2" ] && [ "$PPP_USER_NAME1" != "" ]; then
/bin/scriptlib_util.sh lockusingfile
if [ ! -f $FIRSTFILE1 ]; then
echo "pass" >> $FIRSTFILE1
pppoeloop.sh "1" "$PPP_CONNECT_TYPE1" "$PID_FILE1" &
fi
/bin/scriptlib_util.sh unlockfile 20
fi
if [ "$PPP_CONNECT_TYPE2" != "2" ] && [ "$PPPoEMODE" = "2" ] && [ "$PPP_USER_NAME2" != "" ]; then
if [ ! -f $FIRSTFILE2 ]; then
echo "pass" >> $FIRSTFILE2
pppoeloop.sh "2" "$PPP_CONNECT_TYPE2" "$PID_FILE2" &
fi
fi
if [ "$PPP_CONNECT_TYPE" = "2" ] && [ "$ENABLE_CONNECT" = "1" ]; then
/bin/disconnect.sh pppoe 0
echo "$WAN_MODE" > /tmp/old_mode
sleep 2
pppd 0 &
fi
if [ "$PPP_CONNECT_TYPE1" = "2" ] && [ "$ENABLE_CONNECT1" = "1" ]; then
/bin/disconnect.sh pppoe 1
echo "$WAN_MODE" > /tmp/old_mode
sleep 2
pppd 1 &
fi
if [ "$PPP_CONNECT_TYPE2" = "2" ] && [ "$ENABLE_CONNECT2" = "1" ]; then
/bin/disconnect.sh pppoe 2
echo "$WAN_MODE" > /tmp/old_mode
sleep 2
pppd 2 &
fi
