#!/bin/sh
if [ "$_SNTP_A_M_CTL_" = "y" ]; then
eval `flash get TIMESERVER_ENABLE`
if [ "$TIMESERVER_ENABLE" = "1" ]; then
if [ ! "`route -n | grep ^0.0.0.0`" ]; then exit; fi
fi
else
if [ ! "`route -n | grep ^0.0.0.0`" ]; then exit; fi
fi
if [ "$_TIME_ZONE_TYPE_" = "y" ]; then
eval `flash get TIME_TYPE`
if [ "$TIME_TYPE" != 0 ]; then exit; fi
fi
. /bin/scriptlib.sh
SNTP_LOG=/var/log/sntp.log
if [ "$_SNTP_A_M_CTL_" = "y" ]; then
ENABLE=`flash get TIMESERVER_ENABLE | cut -d '=' -f 2`
if [ "$ENABLE" = "1" ]; then
if [ "$_MODE_" != "Customer" -o "$_MODE_" = "Customer" ] || [ "$SNTP_SERVERADDR_TYPE" = "1" ]; then
TIMESERVER_DOMAIN=`flash get TIMESERVER_DOMAIN | cut -d '=' -f 2 | cut -d "'" -f 2`
if [ "$TIMESERVER_DOMAIN" != "" ]; then
TADDR=`ping -c 1 $TIMESERVER_DOMAIN | grep PING | cut -d '(' -f 2 | cut -d ')' -f 1` 2>/dev/null
if [ "$TADDR" != "" ]; then
TIMESERVER_ADDR=$TADDR
else
if [ "$_MODE_" = "Customer" -o "$_MODE_" = "Customer" ]; then
TIMESERVER_ADDR="0.0.0.0"
fi
fi
else
if [ "$_MODE_" = "Customer" -o "$_MODE_" = "Customer" ]; then
TIMESERVER_ADDR="0.0.0.0"
fi
fi
fi
if [ "$TIMESERVER_ADDR" != "0.0.0.0" ]; then
echo "time server = $TIMESERVER_ADDR"
echo [`date +"%F %T"`]: [SNTP]: connect to TimeServer $TIMESERVER_ADDR ... >> /var/log/security
/bin/sntpclock $TIMESERVER_ADDR $TIME_ZONE_SEL > $SNTP_LOG
if [ $? != 0 ]; then
echo [`date +"%F %T"`]: [SNTP]: connect fail!! >> /var/log/security
else
echo [`date +"%F %T"`]: [SNTP]: connect success! >> /var/log/security
if [ "$DAYLIGHT_ENABLE" = "1" ]; then
echo "check Daylight saving..." >> $SNTP_LOG
MON=`date +%m`
DAY=`date +%d`
if [ "$MON" -gt "$START_MONTH" -a "$MON" -lt "$END_MONTH" -o "$MON" -eq "$START_MONTH" -a "$DAY" -ge "$START_DAY" -o "$MON" -eq "$END_MONTH" -a "$DAY" -le "$END_DAY" ]; then
TIME=[`date +"%F %T"`]
echo "$TIME: [SNTP]: It's daylight saving...add one hour" >> $SNTP_LOG
YEAR=`date +%Y`
HOUR=`date +%H`
MINUTE=`date +%M`
SEC=`date +%S`
HOUR=`expr $HOUR + 1`
date $YEAR.$MON.$DAY-$HOUR:$MINUTE:$SEC
fi
fi
echo [`date +"%F %T"`]: [SNTP]: set time to `date +"%F %T"` >> /var/log/security
fi
if [ "$_WIRELESS_SCHEDULE_" = "y" ] && [ "$WLAN_SCH_ENABLED" = "1" ] && [ "$WLAN_DISABLED" = "0" ]; then
wirelessSchedule
fi
fi
else
STATIC_SYSTEM_TIME=`flash get STATIC_SYSTEM_TIME | cut -d '=' -f 2 | cut -d "'" -f 2`
if [ "$_SNTP_A_M_CTL2_" = "y" ]; then
STATIC_SYSTEM_TIME=`echo $STATIC_SYSTEM_TIME | cut -b 1-4`.`echo $STATIC_SYSTEM_TIME | cut -b 5-6`.`echo $STATIC_SYSTEM_TIME | cut -b 7-8`-`echo $STATIC_SYSTEM_TIME | cut -b 10-11`:`echo $STATIC_SYSTEM_TIME | cut -b 12-13`:`echo $STATIC_SYSTEM_TIME | cut -b 14-15`
fi
echo "static system time:$STATIC_SYSTEM_TIME"
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
if [ ! -f "/tmp/Manual_Time_Has_Been_Set" ]; then
date $STATIC_SYSTEM_TIME
> /tmp/Manual_Time_Has_Been_Set
fi
else
date $STATIC_SYSTEM_TIME
fi
if [ "$_WIRELESS_SCHEDULE_" = "y" ] && [ "$WLAN_SCH_ENABLED" = "1" ] && [ "$WLAN_DISABLED" = "0" ]; then
wirelessSchedule
fi
fi
else
if [ "$_TIME_ZONE_TYPE_" = "y" ]; then
TIMESERVER_DOMAIN=`flash get NTPS_ADDR | cut -d '=' -f 2 | cut -d "'" -f 2`
TADDR=`ping -c 1 $TIMESERVER_DOMAIN | grep PING | cut -d '(' -f 2 | cut -d ')' -f 1` 2>/dev/null
if [ "$TADDR" != "" ]; then
TIMESERVER_ADDR=$TADDR
fi
fi
if [ "$TIMESERVER_ADDR" != "0.0.0.0" ]; then
echo [`date +"%F %T"`]: [SNTP]: connect to TimeServer $TIMESERVER_ADDR ... >> /var/log/security
/bin/sntpclock $TIMESERVER_ADDR $TIME_ZONE_SEL > $SNTP_LOG
if [ $? != 0 ]; then
echo [`date +"%F %T"`]: [SNTP]: connect fail!! >> /var/log/security
else
echo [`date +"%F %T"`]: [SNTP]: connect success! >> /var/log/security
if [ "$DAYLIGHT_ENABLE" = "1" ]; then
echo "check Daylight saving..." >> $SNTP_LOG
MON=`date +%m`
DAY=`date +%d`
if [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6428GN" ]; then
if [ "$MON" -gt "$START_MONTH" -a "$MON" -lt "$END_MONTH" -o "$MON" -eq "$START_MONTH" -a "$DAY" -ge "$START_DAY" -o "$MON" -eq "$END_MONTH" -a "$DAY" -le "$END_DAY" -o  "$MON" -eq "$START_MONTH" -a "$DAY" -eq "$START_DAY" -a "$HOUR" -ge "$START_HOUR" -o  "$MON" -eq "$START_MONTH" -a "$DAY" -eq "$START_DAY" -a "$HOUR" -le "$END_HOUR" ]; then
TIME=[`date +"%F %T"`]
echo "$TIME: [SNTP]: It's daylight saving...add one hour" >> $SNTP_LOG
YEAR=`date +%Y`
MINUTE=`date +%M`
SEC=`date +%S`
HOUR=`expr $HOUR + 1`
date $YEAR.$MON.$DAY-$HOUR:$MINUTE:$SEC
fi					
else
if [ "$MON" -gt "$START_MONTH" -a "$MON" -lt "$END_MONTH" -o "$MON" -eq "$START_MONTH" -a "$DAY" -ge "$START_DAY" -o "$MON" -eq "$END_MONTH" -a "$DAY" -le "$END_DAY" ]; then
TIME=[`date +"%F %T"`]
echo "$TIME: [SNTP]: It's daylight saving...add one hour" >> $SNTP_LOG
YEAR=`date +%Y`
HOUR=`date +%H`
MINUTE=`date +%M`
SEC=`date +%S`
HOUR=`expr $HOUR + 1`
date $YEAR.$MON.$DAY-$HOUR:$MINUTE:$SEC
fi
fi
elif [ "$_AUTO_DAYLIGHT_ENABLE_" != "" ]; then
if [ "$AUTO_DAYLIGHT_ENABLE" = "1" ]; then
echo "check Daylight saving..." >> $SNTP_LOG
MON=`date +%m`
DAY=`date +%d`
START_MONTH=3
END_MONTH=10
START_DAY=26
END_DAY=31
if [ "$MON" -gt "$START_MONTH" -a "$MON" -lt "$END_MONTH" -o "$MON" -eq "$START_MONTH" -a "$DAY" -ge "$START_DAY" -o "$MON" -eq "$END_MONTH" -a "$DAY" -le "$END_DAY" ]; then
TIME=[`date +"%F %T"`]
echo "$TIME: [SNTP]: It's daylight saving...add one hour" >> $SNTP_LOG
YEAR=`date +%Y`
HOUR=`date +%H`
MINUTE=`date +%M`
SEC=`date +%S`
HOUR=`expr $HOUR + 1`
date $YEAR.$MON.$DAY-$HOUR:$MINUTE:$SEC
elif [ "$MON" -eq "$START_MON" -a "$DAY" -eq "$START_DAY"	]; then
START_TIME=2
END_TIME=3
TIM=`date +%H`
if [ "$TIM" -ge "$START_TIME" ]; then
TIME=[`date +"%F %T"`]
echo "$TIME: [SNTP]: It's daylight saving...add one hour" >> $SNTP_LOG
YEAR=`date +%Y`
HOUR=`date +%H`
MINUTE=`date +%M`
SEC=`date +%S`
HOUR=`expr $HOUR + 1`
date $YEAR.$MON.$DAY-$HOUR:$MINUTE:$SEC
fi
elif [ "$MON" -eq "$END_MON" -a "$DAY" -eq "$END_DAY" ]; then
if [ "$TIM" -le "$END_TIME" ]; then
TIME=[`date +"%F %T"`]
echo "$TIME: [SNTP]: It's daylight saving...add one hour" >> $SNTP_LOG
YEAR=`date +%Y`
HOUR=`date +%H`
MINUTE=`date +%M`
SEC=`date +%S`
HOUR=`expr $HOUR + 1`
date $YEAR.$MON.$DAY-$HOUR:$MINUTE:$SEC
fi
fi
fi
fi
echo [`date +"%F %T"`]: [SNTP]: set time to `date +"%F %T"` >> /var/log/security
fi
if [ "$_WIRELESS_SCHEDULE_" = "y" ] && [ "$WLAN_SCH_ENABLED" = "1" ] && [ "$WLAN_DISABLED" = "0" ]; then
wirelessSchedule
fi
fi
fi
