#!/bin/sh
. /web/FUNCTION_SCRIPT
TOOL=flash
GETMIB="$TOOL get"
LOADDEF="$TOOL default"
LOADDS="$TOOL reset"
SETMIB="$TOOL set"
SET_IP=fixedip.sh
START_DHCP_SERVER=dhcpd.sh
START_DHCP_CLIENT=dhcpc.sh
START_BRIDGE=bridge.sh
START_WLAN=wlan.sh
START_PPPOE=pppoe.sh
START_PPTP=pptp.sh
START_FIREWALL=firewall.sh
START_DISCONNECT=disconnect.sh
if [ "$_L2TPD_" != "" ]; then
START_L2TP=l2tp_2.sh
else
START_L2TP=l2tp.sh
fi
START_BPA=bpa.sh
DISCONNECT=2
FIRSTFILE0=/etc/ppp/first0
FIRSTFILE1=/etc/ppp/first1
START_WLAN_APP=wlanapp.sh	#Erwin
SEC_LOG=/var/log/security
WLAN_INTERFACE=wlan0
WLAN_IF2=wlan0
RouteMode=1;
if [ "$_ARSWITCH_" = "y" ]; then
PRESS=`cat /dev/switch_but`
if [ "$PRESS" != "0" ]; then
RouteMode=1;
if [ `flash all | grep -i AP_ROUTER_SWITCH | grep -v grep | cut -d= -f 2` = "1" ]; then
flash set DHCP 2
flash set AP_ROUTER_SWITCH 0			
fi
else
RouteMode=0;
flash set AP_ROUTER_SWITCH 1
flash set DHCP 0
fi
fi
. /bin/scriptlib.sh
echo 1 > /var/killppp
killall pppd
while [ "`ps | grep pppd | grep file`" != "" ]; 
do
sleep 1
killall pppd
done
rmmod usbserial
killall runppp.sh
killall -9 pptp.sh
killall -9 pppoe.sh
rm -f /var/ppp/first*
disconnect.sh all
VLAN1=`cat /proc/net/dev | grep $_LAN_IF_ | cut -d: -f 1`
VLAN2=`cat /proc/net/dev | grep $_WAN_IF_ | cut -d: -f 1`
ifconfig eth2 up
if [ "$VLAN1" != "$_LAN_IF_" ]; then
vconfig add eth2 1
fi
if [ "$VLAN2" != "$_WAN_IF_" ]; then
vconfig add eth2 2
fi
GATEWAY='true'
if [ "$OP_MODE" = '1' ];then
WAN_INTERFACE=$WLAN_IF2
else
WAN_INTERFACE=$_WAN_IF_
fi	
BR_INTERFACE=br0
WLAN_INTERFACE=wlan0
BR_LAN1_INTERFACE=$_LAN_IF_
if [ "$OP_MODE" = '1' ];then
BR_LAN2_INTERFACE=$_WAN_IF_
fi
ENABLE_WAN=1
ENABLE_BR=1
if [ "$ENABLE_WAN" = "1" ]; then
echo 'Setup WAN interface'
$START_DISCONNECT all
rm $FIRSTFILE0 2> /dev/null
rm $FIRSTFILE1 2> /dev/null
rm jj1 2> /dev/null
rm jj2 2> /dev/null
route del default 2> /dev/null
if [ "$_KERNEL_VERSION_26_" != "y" ] && [ "$_IPV6_BRIDGE_" = "y" ] && [ "$IPV6_BRIDGE" = 1 ]; then
ifconfig eth0 down
ifconfig eth1 down
fi
if [ "$WAN_MODE" != '5' ] &&  [ "$RouteMode" = "1" ]; then
brctl delif $BR_INTERFACE $WAN_INTERFACE 2> /dev/null
fi
if [ "$RouteMode" = "1" ]; then
brctl delif br0 eth2
brctl addif br0 $_LAN_IF_
/bin/config-vlan.sh 2 LLLLW
echo "$WAN_MODE" > /tmp/old_mode
if [ "$_EZVIEW_" = "y" ]; then
echo "nameserver 168.95.1.1" > /etc/resolv.conf
fi
if [ "$WAN_MODE" = '1' ]; then
echo [`date +"%F %T"`]: start Static IP >> $SEC_LOG
$SET_IP $WAN_INTERFACE $WAN_IP_ADDR $WAN_SUBNET_MASK $WAN_DEFAULT_GATEWAY
/bin/ipup.sh static
elif [ "$WAN_MODE" = '0' ]; then
echo [`date +"%F %T"`]: start Dynamic IP >> $SEC_LOG
$START_DHCP_CLIENT $WAN_INTERFACE wait&
elif [ "$WAN_MODE" = '2' ]; then
echo [`date +"%F %T"`]: start PPPoE daemon >> $SEC_LOG
$START_PPPOE all &		
elif [ "$WAN_MODE" = '3' ]; then
echo [`date +"%F %T"`]: start PPtP daemon >> $SEC_LOG
$START_PPTP
sleep 2
elif [ "$WAN_MODE" = '4' ]; then
echo [`date +"%F %T"`]: start BPA daemon >> $SEC_LOG
$START_DHCP_CLIENT $WAN_INTERFACE wait&
$START_BPA
elif [ "$WAN_MODE" = '5' ]; then
echo [`date +"%F %T"`]: start Bridge daemon >> $SEC_LOG
$START_BRIDGE $BR_INTERFACE $BR_LAN1_INTERFACE $WLAN_INTERFACE $BR_LAN2_INTERFACE
brctl addif $BR_INTERFACE $WAN_INTERFACE
ifconfig $BR_INTERFACE $IP_ADDR
elif [ "$WAN_MODE" = '6' ]; then
echo [`date +"%F %T"`]: start L2tp daemon >> $SEC_LOG
$START_L2TP
sleep 2
else
echo "Invalid DHCP MIB value for WAN interface! WAN_MODE= $WAN_MODE"
fi
else  
echo "Bridge WAN to LAN"
echo [`date +"%F %T"`]: start Bridge daemon >> $SEC_LOG
brctl delif br0 $_LAN_IF_
brctl addif br0 eth2
/bin/config-vlan.sh 2 0
ifconfig $BR_INTERFACE $IP_ADDR		
fi
fi
if [ "$_KERNEL_VERSION_26_" != "y" ] && [ "$_IPV6_BRIDGE_" = "y" ] && [ "$IPV6_BRIDGE" = 1 ]; then
ifconfig eth0 up
ifconfig eth1 up
fi
/bin/zebra.sh &
/bin/ripd.sh &
/bin/snmpd.sh &
if [ "$GATEWAY" = 'true' ]; then
echo 1 > /proc/sys/net/ipv4/ip_forward
rmmod sw_nat 2> /dev/null 
if [ "$OP_MODE" = '1' ];then
WAN=$WLAN_IF2
else
WAN=$_WAN_IF_
fi
if [ "$WAN_MODE" = "2" ]; then
WAN=ppp0 
fi              
if [ "$WAN_MODE" = "3" ]; then
WAN=ppp0
fi          
if [ "$WAN_MODE" = "6" ]; then
WAN=ppp0
fi          
if [ "$NAT_ENABLE" = "1" ]; then
iptables -t nat -A POSTROUTING -o $WAN -j MASQUERADE
fi
if [ "$WAN" = "$_WAN_IF_" ];then
if [ "$FAST_NAT_ENABLE" = "1" ]; then		
insmod /lib/modules/2.4.18-MIPS/RT2880/sw_nat.o
fi
fi	
fi
