#!/bin/sh
/bin/scriptlib_util.sh reloadFlash
. /bin/scriptlib.sh
temp_mac="`ifconfig br0 | grep HWaddr | cut -b39-55 | tr '[A-Z]' '[a-z]'`"
if [ "$1" = "discover" ]; then
echo "HTTP/1.1 200 OK" > /tmp/upnp_protocol_getinfo
echo "Cache-Control: max-age=120" >> /tmp/upnp_protocol_getinfo
echo "ST: urn:schemas-upnp-org:device:CustomerDevice:1" >> /tmp/upnp_protocol_getinfo
echo "USN: uuid:5e0710f8-351f-11dc-8314-0800200c9a66::urn:schemas-upnp-org:device:CustomerDevice:1" >> /tmp/upnp_protocol_getinfo
echo "EXT:" >> /tmp/upnp_protocol_getinfo
echo "Server: Linux/2.6.15 UPnP/1.0 miniupnpd/1.0" >> /tmp/upnp_protocol_getinfo
echo "Location: http://${IP_ADDR}:80/" >> /tmp/upnp_protocol_getinfo
echo "Model: MZK-WNH" >> /tmp/upnp_protocol_getinfo
echo "Firmware: `cat /etc/version`" >> /tmp/upnp_protocol_getinfo
echo "IP: $IP_ADDR" >> /tmp/upnp_protocol_getinfo
echo "Netmask: $SUBNET_MASK" >> /tmp/upnp_protocol_getinfo
echo "MAC: $temp_mac" >> /tmp/upnp_protocol_getinfo
if [ "$AP_ROUTER_SWITCH" = "0" ]; then
echo "Type: ROUTER" >> /tmp/upnp_protocol_getinfo
else
echo "Type: AP" >> /tmp/upnp_protocol_getinfo
fi
if [ "$DHCP" = "2" ]; then
echo "DHCP: 1" >> /tmp/upnp_protocol_getinfo
else
echo "DHCP: 0" >> /tmp/upnp_protocol_getinfo
fi
elif [ "$1" = "configure" ]; then
if [ -f "/tmp/upnp_sha1key" ] && [ "`cat /tmp/upnp_sha1key`" = "`echo -n ${USER_NAME}:${USER_PASSWORD}:${temp_mac}:MZK-WNH:4289 | sha1sum | cut -b1-40 | tr '[a-z]' '[A-Z]'`" ]; then
auth_pass=1
else
auth_pass=0
fi
if [ "$auth_pass" = "1" ]; then
temp_dhcp="`cat /tmp/upnp_dhcpipmaskgw | cut -f 1 -d :`"
if [ "$temp_dhcp" = "1" ]; then
flash set DHCP 2
else
flash set DHCP 0
fi
temp_ip="`cat /tmp/upnp_dhcpipmaskgw | cut -f 2 -d :`"
if [ "$temp_ip" != "" ]; then
flash set IP_ADDR $temp_ip
fi
temp_mask="`cat /tmp/upnp_dhcpipmaskgw | cut -f 3 -d :`"
if [ "$temp_mask" != "" ]; then
flash set SUBNET_MASK $temp_mask
else
flash set SUBNET_MASK 255.255.255.0
fi
temp_gw="`cat /tmp/upnp_dhcpipmaskgw | cut -f 4 -d :`"
if [ "$temp_gw" != "" ]; then
flash set DEFAULT_GATEWAY $temp_mask
else
flash set DEFAULT_GATEWAY 0.0.0.0
fi
echo "HTTP/1.1 200 OK" > /tmp/upnp_protocol_getinfo
echo "Cache-Control: max-age=120" >> /tmp/upnp_protocol_getinfo
echo "ST: urn:schemas-upnp-org:device:CustomerDevice:1" >> /tmp/upnp_protocol_getinfo
echo "USN: uuid:5e0710f8-351f-11dc-8314-0800200c9a66::urn:schemas-upnp-org:device:CustomerDevice:1" >> /tmp/upnp_protocol_getinfo
echo "EXT:" >> /tmp/upnp_protocol_getinfo
echo "Server: Linux/2.6.15 UPnP/1.0 miniupnpd/1.0" >> /tmp/upnp_protocol_getinfo
echo "MAC: $temp_mac" >> /tmp/upnp_protocol_getinfo
else
echo "HTTP/1.1 401 Unauthorized" > /tmp/upnp_protocol_getinfo
echo "CACHE-CONTROL: max-age=120" >> /tmp/upnp_protocol_getinfo
echo "ST: urn:schemas-upnp-org:device:CustomerDevice:1" >> /tmp/upnp_protocol_getinfo
echo "USN: uuid:5e0710f8-351f-11dc-8314-0800200c9a66::urn:schemas-upnp-org:device:CustomerDevice:1" >> /tmp/upnp_protocol_getinfo
echo "EXT:" >> /tmp/upnp_protocol_getinfo
echo "SERVER: Linux/2.6.15 UPnP/1.0 miniupnpd/1.0" >> /tmp/upnp_protocol_getinfo
echo "LOCATION: http://${IP_ADDR}:80/" >> /tmp/upnp_protocol_getinfo
echo "MODEL: MZK-WNH" >> /tmp/upnp_protocol_getinfo
echo "FIRMWARE: `cat /etc/version`" >> /tmp/upnp_protocol_getinfo
echo "IP: $IP_ADDR" >> /tmp/upnp_protocol_getinfo
echo "NETMASK: $SUBNET_MASK" >> /tmp/upnp_protocol_getinfo
echo "MAC: $temp_mac" >> /tmp/upnp_protocol_getinfo
if [ "$AP_ROUTER_SWITCH" = "0" ]; then
echo "TYPE: ROUTER" >> /tmp/upnp_protocol_getinfo
else
echo "TYPE: AP" >> /tmp/upnp_protocol_getinfo
fi
if [ "$DHCP" = "2" ]; then
echo "DHCP: 1" >> /tmp/upnp_protocol_getinfo
else
echo "DHCP: 0" >> /tmp/upnp_protocol_getinfo
fi
fi
echo $auth_pass > /tmp/upnp_auth_pass
else
echo "Usage: $0 [discover/configure]"
fi
