#!/bin/sh
. /bin/scriptlib.sh
SCRIPT_TITLE="URL Blocking"
debug_print "Cleaning previous status."
if [ "$_URLB_BY_KERNEL_" = "y" ]; then
echo "flush" > proc/filter_table
else
if [ -f /var/clean_urlblocking.sh ]; then
chmod 777 /var/clean_urlblocking.sh
/var/clean_urlblocking.sh
rm -rf /var/clean_urlblocking.sh
fi
fi
debug_print "Checking whether NAT is enabled."
if [ "$NAT_ENABLE" = "0" ]; then
debug_print "NAT is disabled, exit."
exit
else
debug_print "NAT is enabled."
fi
debug_print "Checking whether Firewall is enabled."
if [ "$FIREWALL_ENABLE" = "0" ]; then
debug_print "Firewall is disabled, exit."
exit
else
debug_print "Firewall is enabled."
fi
debug_print "Checking whether URL Blocking is enabled."
if [ "$URLB_ENABLED" = "0" ]; then
debug_print "URL Blocking is disabled, exit."
exit
else
debug_print "URL Blocking is enabled."
fi
debug_print "Setting URL Blocking."
if [ "$_URLB_BY_KERNEL_" = "y" ]; then
if [ "$URLB_TBL_NUM" != "0" ]; then
echo "init 3" > proc/filter_table
echo 1 > /proc/fast_nat
i=0
while [ "$i" != "$URLB_TBL_NUM" -a "$URLB_TBL_NUM" != "0" ]; do
COUNT=`expr $i + 1`
eval param=\$URLB_TBL$COUNT
echo "add:0#3 3 $param " > proc/filter_table
i=`expr $i + 1`
done
fi
else
debug_print_and_execute "iptables -N web_filter"
debug_print_and_execute "iptables -A FORWARD -j web_filter"
echo 0 > /proc/fast_nat
i=0
while [ "$i" != "$URLB_TBL_NUM" -a "$URLB_TBL_NUM" != "0" ]; do
COUNT=`expr $i + 1`
if [ "$_IPV6_SUPPORT_" = "y" ] && [ "$_PLATFORM_" != "RTL8196C_2500" ] && [ "$_PLATFORM_" != "RTL8198_2500" ]; then
debug_print_and_execute "iptables -A web_filter -p tcp -m weburl --contains \"\$URLB_TBL$COUNT\" -j DROP"
elif [ "$_KERNEL_VERSION_26_" = "y" ]; then
debug_print_and_execute "iptables -A web_filter -p tcp -m weburl --contains \"\$URLB_TBL$COUNT\" -j REJECT --reject-with tcp-reset"
else
debug_print_and_execute "iptables -A web_filter -p tcp -m webstr --url \$URLB_TBL$COUNT -j REJECT --reject-with tcp-reset"
fi
i=`expr $i + 1`
done
debug_print "Storing cleaning information."
echo "iptables -D FORWARD -j web_filter 2>\/dev\/null" >> /var/clean_urlblocking.sh
echo "iptables -F web_filter 2>\/dev\/null" >> /var/clean_urlblocking.sh
echo "iptables -X web_filter 2>\/dev\/null" >> /var/clean_urlblocking.sh
fi	
debug_print "Exit."
