#!/bin/sh
. /bin/scriptlib.sh
SCRIPT_TITLE="Virtual Server"
WAN_INTERFACE1="`wan_interface 1`"
WAN_INTERFACE2="`wan_interface 2`"
WAN_INTERFACE3="`wan_interface 3`"
WAN_INTERFACER="`wan_interface R`"
WAN_IP1="`ip_of_interface $WAN_INTERFACE1`"
WAN_IP2="`ip_of_interface $WAN_INTERFACE2`"
WAN_IP3="`ip_of_interface $WAN_INTERFACE3`"
WAN_IPR="`ip_of_interface $WAN_INTERFACER`"
LAN_INTERFACE="`lan_interface`"
LAN_IP="`ip_of_interface $LAN_INTERFACE`"
debug_print "Cleaning previous status."
if [ -f /var/clean_virtualserver.sh ]; then
chmod 777 /var/clean_virtualserver.sh
/var/clean_virtualserver.sh
rm -rf /var/clean_virtualserver.sh
fi
debug_print "Checking whether NAT is enabled."
if [ "$NAT_ENABLE" = "0" ]; then
debug_print "NAT is disabled, exit."
exit 0
else
debug_print "NAT is enabled."
fi
debug_print "Checking whether Virtual Server is enabled."
if [ "$VSER_ENABLED" = "0" ]; then
debug_print "Virtual Server is disable, exit."
exit 0
else
debug_print "Virtual Server is enabled."
fi
debug_print "Setting Virtual Server."
debug_print_and_execute "iptables -t nat -N vserver_SNAT"
debug_print_and_execute "iptables -t nat -A POSTROUTING -j vserver_SNAT"
debug_print_and_execute "iptables -t nat -N vserver_DNAT"
debug_print_and_execute "iptables -t nat -A PREROUTING -j vserver_DNAT"
num=1
while [ $num -le $VSER_TBL_NUM ]; do
eval "port_ip="\$VSER_TBL$num""
ip=`echo $port_ip | cut -f1 -d,`
port1=`echo $port_ip | cut -f2 -d,`
port1=`echo $port1 | cut -f2 -d ' '`
protocol=`echo $port_ip | cut -f3 -d,`
port2=`echo $port_ip | cut -f4 -d,`
port2=`echo $port2 | cut -f2 -d ' '`
session=`echo $port_ip | cut -f5 -d,`
num=`expr $num + 1`
WAN_IP=""
if [ "$session" = "1" ] && [ "$WAN_IP2" != "0.0.0.0" ]; then
WAN_IP=$WAN_IP" "$WAN_IP2
elif [ "$WAN_IP1" != "0.0.0.0" ]; then
WAN_IP=$WAN_IP" "$WAN_IP1
fi
if [ "$_DUALL_WAN_ACCESS_" = "y" ] && [ "$DUALL_ACCESS_ENABLE" = "1" ] && [ "$WAN_IPR" != "0.0.0.0" ]; then
WAN_IP=$WAN_IP" "$WAN_IPR
fi
debug_print "Interfaces:$WAN_IP."
snat_done=0
for WAN in $WAN_IP; do
if [ "$snat_done" = "0" ]; then
debug_print "Set SNAT."
if [ "$_KERNEL_VERSION_26_" = "y" ]; then	
if [ "$protocol" = "1" ] || [ "$protocol" = "3" ]; then
debug_print_and_execute "iptables -A vserver_SNAT -t nat -p TCP -s $LAN_IP/$SUBNET_MASK -d $ip --dport $port1 -j SNAT --to $LAN_IP"
fi
if [ "$protocol" = "2" ] || [ "$protocol" = "3" ]; then
debug_print_and_execute "iptables -A vserver_SNAT -t nat -p UDP -s $LAN_IP/$SUBNET_MASK -d $ip --dport $port1 -j SNAT --to $LAN_IP"
fi
if [ "$port1" -le "1723" ] && [ "$port2" -ge "1723" ]; then
debug_print_and_execute "iptables -A vserver_SNAT -t nat -p 47 -s $LAN_IP/$SUBNET_MASK -d $ip -j SNAT --to $LAN_IP"
fi
else
if [ "$protocol" = "1" ] || [ "$protocol" = "3" ]; then
debug_print_and_execute "iptables -A vserver_SNAT -t nat -p tcp -s $LAN_IP/$SUBNET_MASK -d $ip -m mport --dports $port1 -j SNAT --to-source $LAN_IP"
fi
if [ "$protocol" = "2" ] || [ "$protocol" = "3" ]; then
debug_print_and_execute "iptables -A vserver_SNAT -t nat -p udp -s $LAN_IP/$SUBNET_MASK -d $ip -m mport --dports $port1 -j SNAT --to-source $LAN_IP"
fi
if [ "$port1" -le "1723" ] && [ "$port2" -ge "1723" ]; then
debug_print_and_execute "iptables -A vserver_SNAT -t nat -p 47 -s $LAN_IP/$SUBNET_MASK -d $ip -j SNAT --to-source $LAN_IP"
fi
fi
snat_done=1
fi
debug_print "Set DNAT for $ip."
if [ "$_KERNEL_VERSION_26_" = "y" ]; then			
if [ "$protocol" = "1" ] || [ "$protocol" = "3" ]; then
debug_print_and_execute "iptables -A vserver_DNAT -t nat -p TCP -d $WAN --dport $port2 -j DNAT --to $ip:$port1"
fi
if [ "$protocol" = "2" ] || [ "$protocol" = "3" ]; then
debug_print_and_execute "iptables -A vserver_DNAT -t nat -p UDP -d $WAN --dport $port2 -j DNAT --to $ip:$port1"
fi
if [ "$port1" -le "1723" ] && [ "$port2" -ge "1723" ]; then
debug_print_and_execute "iptables -A vserver_DNAT -t nat -p 47 -d $WAN -j DNAT --to $ip"
fi
else
if [ "$protocol" = "1" ] || [ "$protocol" = "3" ]; then
debug_print_and_execute "iptables -A vserver_DNAT -t nat -p tcp -d $WAN -m mport --dports $port2 -j DNAT --to-destination $ip:$port1"
fi
if [ "$protocol" = "2" ] || [ "$protocol" = "3" ]; then
debug_print_and_execute "iptables -A vserver_DNAT -t nat -p udp -d $WAN -m mport --dports $port2 -j DNAT --to-destination $ip:$port1"
fi
if [ "$port1" -le "1723" ] && [ "$port2" -ge "1723" ]; then
debug_print_and_execute "iptables -A vserver_DNAT -t nat -p 47 -d $WAN -j DNAT --to-destination $ip"
fi		
fi
done
done
debug_print "Storing cleaning information."
echo "iptables -t nat -D POSTROUTING -j vserver_SNAT" >> /var/clean_virtualserver.sh
echo "iptables -t nat -D PREROUTING -j vserver_DNAT" >> /var/clean_virtualserver.sh
echo "iptables -t nat -F vserver_SNAT" >> /var/clean_virtualserver.sh
echo "iptables -t nat -F vserver_DNAT" >> /var/clean_virtualserver.sh
echo "iptables -t nat -X vserver_SNAT" >> /var/clean_virtualserver.sh
echo "iptables -t nat -X vserver_DNAT" >> /var/clean_virtualserver.sh
debug_print "Exit."
