#!/bin/sh
. /bin/scriptlib.sh
TEMPFILE=/var/run/wanstat
TEMPFILE1=/var/run/wanstat1
TEMPFILE2=/var/run/wanstat2
HW_MAC="`ifconfig $_WAN_IF_ | grep HWaddr | cut -b 39-55`"
dns_flag=0
if [ "$DNS1" != "0.0.0.0" ] || [ "$DNS2" != "0.0.0.0" ]; then
dns_flag=1
fi
if [ "$_THIRD_DNS_" = "y" ]; then
if [ "$DNS3" != "0.0.0.0" ]; then
dns_flag=1
fi
fi
if [ "$WAN_MODE" = 0 ]; then
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
connected_string="<script>dw(DHCPConnected)</script>"
disconnected_string="<script>dw(DHCPDisconnected)</script>"
elif [ "$_MODE_" = "Customer" ]; then
connected_string="<script>dw(dhcpCon)</script>"
disconnected_string="<script>dw(dhcpDis)</script>"
else
connected_string="Dynamic IP connect"
disconnected_string="Dynamic IP disconnect"
fi
connect=`ifconfig $_WAN_IF_ | grep "inet addr"`
connect_info=`route -n | grep "^0.0.0.0" | grep "eth1$" | cut -b17-32`
if [ "$_MODE_" = "Customer" ] && [ "`arping -I eth1 -c 1 $connect_info | grep -i Received | cut -d " " -f 2`" = "0" ]; then
connect=""
fi
if [ "$connect" != "" ]; then
echo "$connected_string" > $TEMPFILE
ifconfig $_WAN_IF_ | grep "inet addr" | cut -f 2 -d : | cut -f 1 -d " " >> $TEMPFILE
ifconfig $_WAN_IF_ | grep "inet addr" | cut -f 4 -d : | cut -f 1 -d " " >> $TEMPFILE
elif [ "$_MODE_" = "Customer" ]; then
echo "$disconnected_string" > $TEMPFILE
echo "`ifconfig $_WAN_IF_ | grep \"inet addr\" | cut -f 2 -d : | cut -f 1 -d \" \"` " >> $TEMPFILE
echo "`ifconfig $_WAN_IF_ | grep \"inet addr\" | cut -f 4 -d : | cut -f 1 -d \" \"` " >> $TEMPFILE		
else
echo "$disconnected_string" > $TEMPFILE
echo "" >> $TEMPFILE
echo "" >> $TEMPFILE
fi
echo "$HW_MAC" >> $TEMPFILE
if [ "$dns_flag" = 0 ]; then
pat=`head -n 1 /var/run/dns-tmp | tail -n 1 | cut -f 1 -d":" `
echo "$pat" >> $TEMPFILE
pat=`head -n 2 /var/run/dns-tmp | tail -n 1 | cut -f 1 -d":" `
echo "$pat" >> $TEMPFILE
if [ "$_THIRD_DNS_" = "y" ]; then
pat=`head -n 3 /var/run/dns-tmp | tail -n 1 | cut -f 1 -d":" `
echo "$pat" >> $TEMPFILE
fi
else
if [ "$DNS1" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo "$DNS1" >> $TEMPFILE
fi
if [ "$DNS2" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo "$DNS2" >> $TEMPFILE
fi
if [ "$_THIRD_DNS_" = "y" ]; then
if [ "$DNS3" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo "$DNS3" >> $TEMPFILE
fi
fi
fi
fi
if [ "$WAN_MODE" = 1 ]; then
connect_info=`route -n | grep "^0.0.0.0" | grep "eth1$" | cut -b17-32`
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
echo "<script>dw(FixedIPConnected)</script>" > $TEMPFILE
elif [ "$_MODE_" = "Customer" ]; then
echo "<script>dw(fixedCon)</script>" > $TEMPFILE
elif [ "$_MODE_" = "Customer" ] && [ "`arping -I eth1 -c 1 $connect_info | grep -i Received | cut -d " " -f 2`" = "0" ]; then
echo "Fixed IP disconnect" > $TEMPFILE
elif [ "$_MODE_" = "Customer" ] && [ "$_USB_8712_" = "y" ]; then
if [ "$OP_MODE" = "1" ]; then
if [ "`wpa_cli -i wlan1 status | grep COMPLETED`" != "" ]; then
echo "Static IP connect" > $TEMPFILE
else 
echo "Static IP disconnect" > $TEMPFILE
fi
else
if [ "`ifconfig eth1 | grep -i inet`" != "" ]; then                   
echo "Static IP connect" > $TEMPFILE
else
echo "Static IP disconnect" > $TEMPFILE
fi      
fi
else
echo "Fixed IP connect" > $TEMPFILE
fi
if [ "$_RENEWCON_RELEASECON_" != "" ]; then
if [ "`ifconfig eth1 | grep -i inet`" != "" -o "$_USB_8712_" = "y" ]; then
echo "$WAN_IP_ADDR" | cut -f 2 -d "=" >> $TEMPFILE
else
echo "" >> $TEMPFILE
fi
else
echo "$WAN_IP_ADDR" | cut -f 2 -d"=" >> $TEMPFILE
fi
echo "$WAN_SUBNET_MASK" | cut -f 2 -d"=" >> $TEMPFILE
echo "$HW_MAC" >> $TEMPFILE
if [ "$dns_flag" = 0 ]; then
pat=`head -n 1 /var/run/dns-tmp | tail -n 1 | cut -f 1 -d":" `
echo "$pat" >> $TEMPFILE
echo "" >> $TEMPFILE
else
if [ "$_EZVIEW_" = "y" ]; then
if [ "$DNS1" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS1 >> $TEMPFILE
fi
if [ "$DNS2" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS2 >> $TEMPFILE
fi
if [ "$_THIRD_DNS_" = "y" ]; then
if [ "$DNS3" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS3 >> $TEMPFILE
fi
fi
else
echo "$DNS1" >> $TEMPFILE
echo "$DNS2" >> $TEMPFILE
if [ "$_THIRD_DNS_" = "y" ]; then
echo "$DNS3" >> $TEMPFILE
fi
fi
fi
fi
if [ "$WAN_MODE" = 2 ]; then
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
connected_string="<script>dw(PPPoEConnected)</script>"
disconnected_string="<script>dw(PPPoEDisconnected)</script>"
elif [ "$_MODE_" = "Customer" ]; then
connected_string="<script>dw(pppCon)</script>"
disconnected_string="<script>dw(pppDis)</script>"
else
connected_string="PPPoE connected"
disconnected_string="PPPoE disconnected"
fi
if [ -f /etc/ppp/link0 ]; then
connect=1
else
connect=""
fi
if [ "$connect" ]; then
echo "$connected_string" > $TEMPFILE
ifconfig ppp0 | grep "inet addr" | cut -f 2 -d : | cut -f 1 -d " " >> $TEMPFILE
ifconfig ppp0 | grep "inet addr" | cut -f 4 -d : | cut -f 1 -d " " >> $TEMPFILE
else
echo "$disconnected_string" > $TEMPFILE
echo "" >> $TEMPFILE
echo "" >> $TEMPFILE
fi
echo "$HW_MAC" >> $TEMPFILE
if [ "$dns_flag" = 0 ]; then
pat=`head -n 1 /etc/resolv.conf | tail -n 1 | cut -f 2 -d" "`
echo "$pat" >> $TEMPFILE
pat=`head -n 2 /etc/resolv.conf | tail -n 1 | cut -f 2 -d" "`
echo "$pat" >> $TEMPFILE
if [ "$_THIRD_DNS_" = "y" ]; then
pat=`head -n 3 /etc/resolv.conf | tail -n 1 | cut -f 2 -d" "`
echo "$pat" >> $TEMPFILE
fi
else
if [ "$DNS1" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS1 >> $TEMPFILE
fi
if [ "$DNS2" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS2 >> $TEMPFILE
fi
if [ "$_THIRD_DNS_" = "y" ]; then
if [ "$DNS3" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS3 >> $TEMPFILE
fi
fi
fi
if [ "$_MPPPOE_" = "y" -a "$PPPoEMODE" = "2" ]; then
if [ -f /etc/ppp/link1 ]; then
connect=1
else
connect=""
fi
if [ "$connect" ]; then
echo "$connected_string" > $TEMPFILE1
ifconfig ppp1 | grep "inet addr" | cut -f 2 -d : | cut -f 1 -d " " >> $TEMPFILE1
ifconfig ppp1 | grep "inet addr" | cut -f 4 -d : | cut -f 1 -d " " >> $TEMPFILE1
else
echo "$disconnected_string" > $TEMPFILE1
echo "" >> $TEMPFILE1
echo "" >> $TEMPFILE1
fi
echo "$HW_MAC" >> $TEMPFILE1
if [ "$dns_flag" = 0 ]; then
if [ -f /etc/resolv1.conf ]; then
pat=`head -n 1 /etc/resolv1.conf | tail -n 1 | cut -f 2 -d" "`
echo "$pat" >> $TEMPFILE1
pat=`head -n 2 /etc/resolv1.conf | tail -n 1 | cut -f 2 -d" "`
echo "$pat" >> $TEMPFILE1
if [ "$_THIRD_DNS_" = "y" ]; then
pat=`head -n 3 /etc/resolv1.conf | tail -n 1 | cut -f 2 -d" "`
echo "$pat" >> $TEMPFILE1
fi
else
echo "" >> $TEMPFILE1
echo "" >> $TEMPFILE1
if [ "$_THIRD_DNS_" = "y" ]; then
echo "" >> $TEMPFILE1
fi
fi
else
if [ "$DNS1" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE1
else
echo $DNS1 >> $TEMPFILE1
fi
if [ "$DNS2" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE1
else
echo $DNS2 >> $TEMPFILE1
fi
if [ "$_THIRD_DNS_" = "y" ]; then
if [ "$DNS3" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE1
else
echo $DNS3 >> $TEMPFILE1
fi
fi
fi
fi
if [ "$_TRIPPPOE_" != "" -a "$PPPoEMODE" = "2" ]; then
if [ -f /etc/ppp/link2 ]; then
connect=1
else
connect=""
fi
if [ "$connect" ]; then
echo "$connected_string" > $TEMPFILE2
ifconfig ppp2 | grep "inet addr" | cut -f 2 -d : | cut -f 1 -d " " >> $TEMPFILE2
ifconfig ppp2 | grep "inet addr" | cut -f 4 -d : | cut -f 1 -d " " >> $TEMPFILE2
else
echo "$disconnected_string" > $TEMPFILE2
echo "" >> $TEMPFILE2
echo "" >> $TEMPFILE2
fi
echo "$HW_MAC" >> $TEMPFILE2
if [ "$dns_flag" = 0 ]; then
if [ -f /etc/ppp/resolv2.conf ]; then
pat=`head -n 1 /etc/resolv2.conf | tail -n 1 | cut -f 2 -d" "`
echo "$pat" >> $TEMPFILE2
pat=`head -n 2 /etc/resolv2.conf | tail -n 1 | cut -f 2 -d" "`
echo "$pat" >> $TEMPFILE2
if [ "$_THIRD_DNS_" = "y" ]; then
pat=`head -n 3 /etc/resolv2.conf | tail -n 1 | cut -f 2 -d" "`
echo "$pat" >> $TEMPFILE2
fi
else
echo "" >> $TEMPFILE2
echo "" >> $TEMPFILE2
if [ "$_THIRD_DNS_" = "y" ]; then
echo "" >> $TEMPFILE2
fi
fi
else
if [ "$DNS1" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE2
else
echo $DNS1 >> $TEMPFILE2
fi
if [ "$DNS2" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE2
else
echo $DNS2 >> $TEMPFILE2
fi
if [ "$_THIRD_DNS_" = "y" ]; then
if [ "$DNS3" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE2
else
echo $DNS3 >> $TEMPFILE2
fi
fi
fi
fi
fi
if [ "$WAN_MODE" = 3 ]; then
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
connected_string="<script>dw(PPTPConnected)</script>"
disconnected_string="<script>dw(PPTPDisconnected)</script>"
else
connected_string="PPTP connected"
disconnected_string="PPTP disconnected"
fi
if [ -f /etc/ppp/link0 ]; then
connect=1
else
connect=""
fi
if [ "$connect" ]; then
echo "$connected_string" > $TEMPFILE
ifconfig ppp0 | grep "inet addr" | cut -f 2 -d : | cut -f 1 -d " " >> $TEMPFILE
ifconfig ppp0 | grep "inet addr" | cut -f 4 -d : | cut -f 1 -d " " >> $TEMPFILE
else
echo "$disconnected_string" > $TEMPFILE
echo "" >> $TEMPFILE
echo "" >> $TEMPFILE
fi
echo "$HW_MAC" >> $TEMPFILE
if [ "$dns_flag" = 0 ]; then
if [ "$_MODE_" = "Customer" ]; then
pat=`cat /etc/resolv.conf | grep nameserver | head -n 1 | cut -f 2 -d " "`
echo "$pat" >> $TEMPFILE
pat=`cat /etc/resolv.conf | grep nameserver | head -n 2 | tail -n 1 | cut -f 2 -d " "`
echo "$pat" >> $TEMPFILE
if [ "$_THIRD_DNS_" = "y" ]; then
pat=`cat /etc/resolv.conf | grep nameserver | head -n 3 | tail -n 1 | cut -f 2 -d " "`
echo "$pat" >> $TEMPFILE
fi
else
pat=`head -n 1 /var/run/dns-tmp | tail -n 1 | cut -f 1 -d":" `
echo "$pat" >> $TEMPFILE
pat=`head -n 2 /var/run/dns-tmp | tail -n 1 | cut -f 1 -d":" `
echo "$pat" >> $TEMPFILE
fi
else
if [ "$DNS1" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS1 >> $TEMPFILE
fi
if [ "$DNS2" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS2 >> $TEMPFILE
fi
if [ "$_THIRD_DNS_" = "y" ]; then
if [ "$DNS3" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS3 >> $TEMPFILE
fi
fi
fi
fi
if [ "$WAN_MODE" = 6 ]; then
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
connected_string="<script>dw(L2TPConnected)</script>"
disconnected_string="<script>dw(L2TPDisconnected)</script>"
else
connected_string="L2TP connected"
disconnected_string="L2TP disconnected"
fi
if [ -f /etc/ppp/link0 ]; then
connect=1
else
connect=""
fi
if [ "$connect" ]; then
L2TP_IP="`ifconfig ppp0 | grep \"inet addr\" | cut -f 2 -d\":\" | cut -f 1 -d\" \"`"
if [ "$L2TP_IP" = "10.64.64.64" ] || [ "$L2TP_IP" = "" ]; then
echo "$disconnected_string" > $TEMPFILE
else
echo "$connected_string" > $TEMPFILE
fi
ifconfig ppp0 | grep "inet addr" | cut -f 2 -d : | cut -f 1 -d " " >> $TEMPFILE
ifconfig ppp0 | grep "inet addr" | cut -f 4 -d : | cut -f 1 -d " " >> $TEMPFILE
else
echo "$disconnected_string" > $TEMPFILE
echo "" >> $TEMPFILE
echo "" >> $TEMPFILE
fi
echo "$HW_MAC" >> $TEMPFILE
if [ "$dns_flag" = 0 ]; then
if [ "$_MODE_" = "Customer" ]; then
pat=`cat /etc/resolv.conf | grep nameserver | head -n 1 | cut -f 2 -d " "`
echo "$pat" >> $TEMPFILE
pat=`cat /etc/resolv.conf | grep nameserver | head -n 2 | tail -n 1 | cut -f 2 -d " "`
echo "$pat" >> $TEMPFILE
if [ "$_THIRD_DNS_" = "y" ]; then
pat=`cat /etc/resolv.conf | grep nameserver | head -n 3 | tail -n 1 | cut -f 2 -d " "`
echo "$pat" >> $TEMPFILE
fi
else
pat=`head -n 1 /var/run/dns-tmp | tail -n 1 | cut -f 1 -d":" `
echo "$pat" >> $TEMPFILE
pat=`head -n 2 /var/run/dns-tmp | tail -n 1 | cut -f 1 -d":" `
echo "$pat" >> $TEMPFILE
fi
else
if [ "$DNS1" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS1 >> $TEMPFILE
fi
if [ "$DNS2" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS2 >> $TEMPFILE
fi
if [ "$_THIRD_DNS_" = "y" ]; then
if [ "$DNS3" = "0.0.0.0" ]; then
echo "" >> $TEMPFILE
else
echo $DNS3 >> $TEMPFILE
fi
fi
fi
fi
