#!/bin/sh
#
# script file to start WLAN
#
if [ $# -lt 1 ]; then echo "Usage: $0 wlan_interface";  exit 1 ; fi

. /web/FUNCTION_SCRIPT
#include file
. /bin/scriptlib.sh

GETMIB="flash get"
#GETMIB="flash get $1"
SET_WLAN="iwpriv $1"
SET_WLAN_PARAM="$SET_WLAN set_mib"
IFCONFIG=ifconfig
START_WLAN_APP=wlanapp.sh
MAX_WDS_NUM=4

## Disable WLAN MAC driver and shutdown interface first ##
$IFCONFIG $1 down

if [ "$_CARRIER_" = "y" ] && [ "$1" = "wlan0" ]; then	#Walter support carrier detect , bandwith 20 support channel 14-15 , bandwith 40 support channel 1-15
	iwpriv wlan0 set_mib edcca_thd=35
fi
IsVAP=`echo $1 | cut -b 7-8` #如果是MSSID的話，IsVAP=va
VAP=`echo $1 | cut -b 7-`
if [ "$VAP" != "" ]; then
	# wlan0-va? interface
	$START_WLAN_APP kill $1
	if [ "$WLAN_DISABLED" = '1' ]; then
		echo 3 > /proc/wlan_led #1:on 2:blink 3:off
		exit 1
	fi

	echo 2 > /proc/wlan_led #1:on 2:blink 3:off

else
	# shutdown all WDS interface
	num=0
	while [ $num -lt $MAX_WDS_NUM ]
	do
		$IFCONFIG $1-wds$num down
		num=`expr $num + 1`
	done

	## kill wlan application daemon ##
	$START_WLAN_APP kill $1
	if [ "$WLAN_DISABLED" = '1' -o "$HW_RF_TYPE" = '0' ]; then
		echo 3 > /proc/wlan_led #1:on 2:blink 3:off
		exit 1
	fi
	echo 2 > /proc/wlan_led #1:on 2:blink 3:off
	## check vap state ##
	if [ "$AP_MODE" = '0' ] || [ "$AP_MODE" = '5' ] || [ "$AP_MODE" = '6' ] || [ "$AP_MODE" = '8' ]; then
		if [ "$_MSSID_" = "y" ]; then
			eval `$GETMIB SSID_MIRROR_1`
			eval `$GETMIB SSID_MIRROR_2`
			eval `$GETMIB SSID_MIRROR_3`
			eval `$GETMIB SSID_MIRROR_4`
			if [ "$1" = "wlan0" ]; then
				if [ "$SSID_MIRROR_1" = '0' ] && [ "$SSID_MIRROR_2" = '0' ] && [ "$SSID_MIRROR_3" = '0' ] && [ "$SSID_MIRROR_4" = '0' ]; then
					$SET_WLAN_PARAM vap_enable=0
				else
					$SET_WLAN_PARAM vap_enable=1
				fi
			fi
		fi
	else
			$SET_WLAN_PARAM vap_enable=0
	fi
fi

## Set parameters to driver ##
#eval `$GETMIB HW_REG_DOMAIN`
$SET_WLAN_PARAM regdomain=$HW_REG_DOMAIN

if [ "$WLAN_MAC_ADDR" = "000000000000" ]; then
	if [ "$VAP" = "" ]; then
		WLAN_MAC_ADDR=$HW_WLAN_ADDR	#set VAP MAC ADDR
	elif [ "$VAP" = "va0" ]; then
		WLAN_MAC_ADDR=$HW_WLAN_ADDR1
	elif [ "$VAP" = "va1" ]; then
		WLAN_MAC_ADDR=$HW_WLAN_ADDR2
	elif [ "$VAP" = "va2" ]; then
		WLAN_MAC_ADDR=$HW_WLAN_ADDR3
	elif [ "$VAP" = "va3" ]; then
		WLAN_MAC_ADDR=$HW_WLAN_ADDR4
	elif [ "$VAP" = "va4" ]; then
		WLAN_MAC_ADDR=$HW_WLAN_ADDR5
	elif [ "$VAP" = "va5" ]; then
		WLAN_MAC_ADDR=$HW_WLAN_ADDR6
	elif [ "$VAP" = "va6" ]; then
		WLAN_MAC_ADDR=$HW_WLAN_ADDR7
	elif [ "$VAP" = "vxd" ]; then
		WLAN_MAC_ADDR=$HW_WLAN_ADDR
	fi
fi

if [ "$1" = "wlan0" ]; then
	WLAN_MAC_ADDR=$HW_WLAN_ADDR
	$IFCONFIG $1 hw ether $WLAN_MAC_ADDR
fi

# ifconfig all wlan interface when not in WISP
# ifconfig wlan1 later interface when in WISP mode, the wlan0  will be setup in WAN interface
if [ "$VAP" = "" ]; then
	if [ "$OP_MODE" != '0' ] || [ $1 != "wlan$WISP_WAN_ID" ] ;then
		$IFCONFIG $1 hw ether $WLAN_MAC_ADDR
	fi
	if [ "$OP_MODE" != '0' ]; then
		$SET_WLAN_PARAM disable_brsc=1
	fi
	$SET_WLAN_PARAM led_type=$HW_LED_TYPE

	## set AP/client/WDS mode ##
	if [ "$AP_MODE" = '2' ]; then
	## client mode
		if  [ "$NETWORK_TYPE" = '0' ]; then
			$SET_WLAN_PARAM opmode=8
		else
			$SET_WLAN_PARAM opmode=32
			$SET_WLAN_PARAM defssid="$SSID"
		fi
	else
	## AP mode
		$SET_WLAN_PARAM opmode=16
	fi
	if [ "$AP_MODE" = '3' -o "$AP_MODE" = '4' ]; then
	## WDS only
		$SET_WLAN_PARAM wds_pure=1
	else
		$SET_WLAN_PARAM wds_pure=0
	fi

#add for mesh
	# 802.11s set mesh parameters ====================
if [ "AP_MODE" = '9' ]; then #EDX not support
	if [ "$AP_MODE" = '4' ]; then
		$SET_WLAN_PARAM mesh_enable=1
		$SET_WLAN_PARAM mesh_ap_enable=1
		$SET_WLAN_PARAM mesh_portal_enable=1
	elif [ "$AP_MODE" = '5' ]; then
		$SET_WLAN_PARAM mesh_enable=1
		$SET_WLAN_PARAM mesh_portal_enable=1
	elif [ "$AP_MODE" = '6' ]; then
		$SET_WLAN_PARAM mesh_enable=1
		$SET_WLAN_PARAM mesh_ap_enable=1
	elif [ "$AP_MODE" = '7' ]; then
		$SET_WLAN_PARAM mesh_enable=1
	fi

	if [ "$AP_MODE" = '4' -o "$AP_MODE" = '5' -o "$AP_MODE" = '6' -o "$AP_MODE" = '7' ]; then
		#eval `$GETMIB MESH_ROOT_ENABLE`
		if [ "$MESH_ROOT_ENABLE" = 0 ]; then
			$SET_WLAN_PARAM mesh_root_enable=0
		else
			$SET_WLAN_PARAM mesh_root_enable=1
		fi

		#eval `$GETMIB MESH_ID`
		$SET_WLAN_PARAM mesh_id="$MESH_ID"

		#eval `$GETMIB MESH_MAX_NEIGHTBOR`
		$SET_WLAN_PARAM mesh_max_neightbor=$MESH_MAX_NEIGHTBOR

		#eval `$GETMIB MIB_MESH_WPA_AUTH`
		$SET_WLAN_PARAM mesh_privacy=$MIB_MESH_WPA_AUTH
	fi
fi
	# ====================
#add for mesh
	# set RF parameters
	#eval `$GETMIB HW_BOARD_ID`
#	if [ "$HW_BOARD_ID" = '1' ]; then #2T2R
#		$SET_WLAN_PARAM MIMO_TR_mode=3
#	elif  [ "$HW_BOARD_ID" = '2' ]; then
#		$SET_WLAN_PARAM MIMO_TR_mode=4 #1T1R
#	else
#		$SET_WLAN_PARAM MIMO_TR_mode=1 #1T2R
#	fi

	if [ "$_RFTYPE_" = "2T2R" ]; then #2T2R
		$SET_WLAN_PARAM MIMO_TR_mode=3

	else
		$SET_WLAN_PARAM MIMO_TR_mode=4
	fi
	$SET_WLAN_PARAM pwrlevelCCK_A=$HW_TX_POWER_CCK_A
	$SET_WLAN_PARAM pwrlevelCCK_B=$HW_TX_POWER_CCK_B
	$SET_WLAN_PARAM pwrlevelHT40_1S_A=$HW_TX_POWER_HT40_1S_A
	$SET_WLAN_PARAM pwrlevelHT40_1S_B=$HW_TX_POWER_HT40_1S_B
	$SET_WLAN_PARAM pwrdiffHT40_2S=$HW_TX_POWER_DIFF_HT40_2S
	$SET_WLAN_PARAM pwrdiffHT20=$HW_TX_POWER_DIFF_HT20
	$SET_WLAN_PARAM pwrdiffOFDM=$HW_TX_POWER_DIFF_OFDM
        
	txpower.sh

	$SET_WLAN_PARAM tssi1=$HW_11N_TSSI1
	$SET_WLAN_PARAM tssi2=$HW_11N_TSSI2
	$SET_WLAN_PARAM ther=$HW_11N_THER
	$SET_WLAN_PARAM bcnint=$BEACON_INTERVAL
#	if [ "$OP_MODE" != '0' ] && [ "$1" = "wlan0" ]; then
#		$SET_WLAN_PARAM channel=$STADRV_CHANNEL
#	else
#		$SET_WLAN_PARAM channel=$CHANNEL
#	fi
else
	# vap, set AP mode always
	$SET_WLAN_PARAM opmode=16
	$IFCONFIG $1 hw ether $WLAN_MAC_ADDR
	$SET_WLAN_PARAM ssid="$SSID"
fi

	if [ "$OP_MODE" != '0' ] && [ "$1" = "wlan0" ]; then
		$SET_WLAN_PARAM channel=$STADRV_CHANNEL
	else
		$SET_WLAN_PARAM channel=$CHANNEL
	fi

if [ "$AP_MODE" = '6' ] && [ "$1" = "wlan0-vxd" ]; then
	$SET_WLAN_PARAM opmode=8
	$SET_WLAN_PARAM ssid="$REPEATER_SSID"
	$SET_WLAN_PARAM 802_1x=0 #in repeater mode 加密方式從wpa切到wep需重開機才能通
elif [ "$OP_MODE" != '0' ] && [ "$1" = "wlan0" ]; then
	$SET_WLAN_PARAM opmode=8
	$SET_WLAN_PARAM ssid="$STADRV_SSID"
elif [ "$IsVAP" != "va" ]; then
	if [ "$_MODE_" = "PCI" ] || [ "$_MODE_" = "Buffalo" ]; then
		if [ "$_MODEL_" = "BR6428GNL" ]; then
			if [ "`cat /proc/pci_threeway_switch`" = "2" ]; then
				$SET_WLAN_PARAM ssid="$REPEATER_SSID"
			else
				$SET_WLAN_PARAM ssid="$SSID"
			fi
		elif [ "$_MODEL_" = "BR6258GN" ]; then
			if [ "$OPERATION_MODE" = "3" ]; then
				$SET_WLAN_PARAM ssid="$REPEATER_SSID"
			else
				$SET_WLAN_PARAM ssid="$SSID"
			fi
		fi
	else
		$SET_WLAN_PARAM ssid="$SSID"
	fi
fi


# set vap MSSID ssid
if [ "$_MSSID_" = "y" ]; then
	mssid2.sh $1 setssid
fi

#$SET_WLAN_PARAM basicrates=$BASIC_RATES
$SET_WLAN_PARAM oprates=$SUPPORTED_RATES
if [ "$RATE_ADAPTIVE_ENABLED" = '0' ]; then
	$SET_WLAN_PARAM autorate=0
	#eval `$GETMIB FIX_RATE`
	rate=`expr $FIX_RATE + $WLAN_N_FIXRATE`
	$SET_WLAN_PARAM fixrate=$rate
else
	$SET_WLAN_PARAM autorate=1
fi
$SET_WLAN_PARAM rtsthres=$RTS_THRESHOLD
$SET_WLAN_PARAM fragthres=$FRAG_THRESHOLD
$SET_WLAN_PARAM expired_time=$INACTIVITY_TIME
$SET_WLAN_PARAM preamble=$PREAMBLE_TYPE

# hidden AP
if [ "$1" = "wlan0" ]; then
eval `$GETMIB HIDDEN_SSID`
$SET_WLAN_PARAM hiddenAP=$HIDDEN_SSID
fi
# set MSSID hidden AP
if [ "$_MSSID_" = "y" ]; then
	mssid2.sh $1 hiddenssid
fi

# hidden AP
if [ "$1" = "wlan0" ]; then
eval `$GETMIB HIDDEN_SSID`
$SET_WLAN_PARAM hiddenAP=$HIDDEN_SSID
fi

# set MSSID hidden AP
if [ "$_MSSID_" = "y" ]; then
	mssid2.sh $1 hiddenssid
fi


if [ "$_MODE_" = "PCI" ] || [ "$_MODE_" = "Buffalo" ]; then
	if [ "$WLAN_MACAC_ENABLED" = 1 ]; then
		OK_LETS_DO_IT=1
		if [ "$WLACL_DENY" = "1" ]; then
			ACLMODE=1
		else
			ACLMODE=2
		fi
	else
		OK_LETS_DO_IT=0
		ACLMODE=0
	fi
elif [ "$_MODE_" = "Hawking" ]; then
	if [ "$WLAN_MACAC_ENABLED" = 1 ] ;then
		OK_LETS_DO_IT=1
		ACLMODE=1
	else
		OK_LETS_DO_IT=0
		ACLMODE=0
	fi
else
	if [ "$WLAN_MACAC_ENABLED" = 1 ] && [ $WLAN_MACAC_NUM -gt 0 ];then
		OK_LETS_DO_IT=1
		ACLMODE=1
	else
		OK_LETS_DO_IT=0
		ACLMODE=0
	fi
fi

if [ "$OK_LETS_DO_IT" = 1 ]; then
	iwpriv wlan0 set_mib aclnum=0
	iwpriv wlan0 set_mib aclmode=$ACLMODE
	if [ "$_MSSID_" = "y" ]; then
		iwpriv wlan0-va0 set_mib aclmode=$ACLMODE
		iwpriv wlan0-va1 set_mib aclmode=$ACLMODE
		iwpriv wlan0-va2 set_mib aclmode=$ACLMODE
		iwpriv wlan0-va3 set_mib aclmode=$ACLMODE
		iwpriv wlan0-va4 set_mib aclmode=$ACLMODE
	fi
	num=1
	while [ $num -le $WLAN_MACAC_NUM ]; do
		eval "acladdr=\$WLAN_MACAC_ADDR$num"
		iwpriv wlan0 set_mib acladdr=$acladdr
		num=`expr $num + 1`
	done
else
	iwpriv wlan0 set_mib aclnum=0
	iwpriv wlan0 set_mib aclmode=$ACLMODE
	if [ "$_MSSID_" = "y" ]; then
		iwpriv wlan0-va0 set_mib aclmode=$ACLMODE
		iwpriv wlan0-va1 set_mib aclmode=$ACLMODE
		iwpriv wlan0-va2 set_mib aclmode=$ACLMODE
		iwpriv wlan0-va3 set_mib aclmode=$ACLMODE
		iwpriv wlan0-va4 set_mib aclmode=$ACLMODE
	fi
fi

if [ "$AUTH_TYPE" = '1' ] && [ "$WLAN_ENCRYPT" != '1' ]; then
	# shared-key and not WEP enabled, force to open-system
	AUTH_TYPE=0
fi
$SET_WLAN_PARAM authtype=$AUTH_TYPE

#Disable WAPI first
#EDX if [ "$WLAN_ENCRYPT" != '7' ]; then
#EDX	$SET_WLAN_PARAM wapiType=0
#EDX fi

if [ "$OP_MODE" != '0' ] && [ "$1" = "wlan0" ]; then
	if [ "$STADRV_ENCRYPT_TYPE" = '0' ]; then
		$SET_WLAN_PARAM encmode=0
	elif [ "$STADRV_ENCRYPT_TYPE" = '1' ]; then
		### WEP mode ##
		if [ "$STADRV_WEP_LENGTH" = '0' ]; then
			$SET_WLAN_PARAM encmode=1
		else
			$SET_WLAN_PARAM encmode=5
		fi
		$SET_WLAN_PARAM wepkey1=$STADRV_WEPKEY1
		$SET_WLAN_PARAM wepkey2=$STADRV_WEPKEY2
		$SET_WLAN_PARAM wepkey3=$STADRV_WEPKEY3
		$SET_WLAN_PARAM wepkey4=$STADRV_WEPKEY4
		$SET_WLAN_PARAM wepdkeyid=$STADRV_WEP_DEFAULT_KEY
	else
        	## WPA mode ##
		$SET_WLAN_PARAM encmode=2
	fi
else
	if [ "$IsVAP" != "va" ]; then
		if [ "$WLAN_ENCRYPT" = '0' ]; then	#0:disable 1:WEP 2:WPA-preshare 3WPA RADIUAS
			$SET_WLAN_PARAM encmode=0
		elif [ "$WLAN_ENCRYPT" = '1' ]; then
			### WEP mode ##
			#eval `$GETMIB WEP`
			if [ "$WEP" = '1' ]; then
				$SET_WLAN_PARAM encmode=1
				$SET_WLAN_PARAM wepkey1=$WEP64_KEY1
				$SET_WLAN_PARAM wepkey2=$WEP64_KEY2
				$SET_WLAN_PARAM wepkey3=$WEP64_KEY3
				$SET_WLAN_PARAM wepkey4=$WEP64_KEY4
				$SET_WLAN_PARAM wepdkeyid=$WEP_DEFAULT_KEY
			else
				$SET_WLAN_PARAM encmode=5
				$SET_WLAN_PARAM wepkey1=$WEP128_KEY1
				$SET_WLAN_PARAM wepkey2=$WEP128_KEY2
				$SET_WLAN_PARAM wepkey3=$WEP128_KEY3
				$SET_WLAN_PARAM wepkey4=$WEP128_KEY4
				$SET_WLAN_PARAM wepdkeyid=$WEP_DEFAULT_KEY
		fi
		elif [ "$WLAN_ENCRYPT" = '7' ]; then
			##WAPI##
			$SET_WLAN_PARAM encmode=7
			$SET_WLAN_PARAM authtype=0
			$SET_WLAN_PARAM wapiPsk=$WAPI_PSK,$WAPI_PSKLEN
			$SET_WLAN_PARAM wapiType=$WAPI_AUTH
			$SET_WLAN_PARAM wapiType=$WAPI_AUTH
			$SET_WLAN_PARAM wapiUCastKeyType=$WAPI_UCASTREKEY
			$SET_WLAN_PARAM wapiUCastKeyTimeout=$WAPI_UCAST_TIME
			$SET_WLAN_PARAM wapiUCastKeyPktNum=$WAPI_UCAST_PACKETS
			$SET_WLAN_PARAM wapiMCastKeyTyp=$WAPI_MCASTREKEY
			$SET_WLAN_PARAM wapiMCastKeyTimeout=$WAPI_MCAST_TIME
			$SET_WLAN_PARAM wapiMCastKeyPktNum=$WAPI_MCAST_PACKETS
		else
	     	## WPA mode ##
			$SET_WLAN_PARAM encmode=2
		fi
	fi #end $IsVAP" != "va"
fi

#set MSSID ENCRYPT
if [ "$_MSSID_" = "y" ]; then
	mssid2.sh $1 setMSSIDwep
fi #end MSSID=y

iwpriv wlan0 set_mib 802_1x=$WLAN_ENABLE_1X
if [ "$_MSSID_" = "y" ]; then
	iwpriv wlan0-va0 set_mib 802_1x=$WLAN_ENABLE_1X_1
	iwpriv wlan0-va1 set_mib 802_1x=$WLAN_ENABLE_1X_2
	iwpriv wlan0-va2 set_mib 802_1x=$WLAN_ENABLE_1X_3
	iwpriv wlan0-va3 set_mib 802_1x=$WLAN_ENABLE_1X_4
	iwpriv wlan0-va4 set_mib 802_1x=$WLAN_ENABLE_1X_5
fi

## set WDS ##
#eval `$GETMIB WDS_ENABLED`
#eval `$GETMIB WDS_NUM`
$SET_WLAN_PARAM wds_num=0

if [ $AP_MODE = '3' -o $AP_MODE = '4' -o $AP_MODE = '5' ]; then
	num=0
	addr_num=1
	while [ $addr_num -le $MAX_WDS_NUM ]
	do
		eval "WL_LINKMAC="\$WL_LINKMAC$addr_num""
                if [ "$WL_LINKMAC" != "000000000000" ]; then
			$SET_WLAN_PARAM wds_add=$WL_LINKMAC,0
			num=`expr $num + 1`
		fi
		if [ $AP_MODE = '3' ]; then
			addr_num=`expr $addr_num + $MAX_WDS_NUM`
		else
			addr_num=`expr $addr_num + 1`
		fi
	done
	$SET_WLAN_PARAM wds_enable=1
else
	$SET_WLAN_PARAM wds_enable=0
fi

if [ "$AP_MODE" = 12 -o "$AP_MODE" = 13 ] && [ "$WDS_ENABLED" != 0 ] && [ "$WDS_NUM" != 0 ]; then
	num=1
	while [ $num -le $WDS_NUM ]
	do
		WDS_TBL=`$GETMIB WDS | grep WDS$num`
		addr_comment=`echo $WDS_TBL | cut -f2 -d=`
		addr=`echo $addr_comment | cut -f1 -d,`
		txrate=`echo $addr_comment | cut -f2 -d,`
		$SET_WLAN_PARAM wds_add=$addr,$txrate
		num=`expr $num - 1`
		$IFCONFIG $1-wds$num hw ether $WLAN_MAC_ADDR
		num=`expr $num + 2`
	done
	$SET_WLAN_PARAM wds_enable=$WDS_ENABLED
fi

if [ "$AP_MODE" = 3 -o "$AP_MODE" = 4 -o "$AP_MODE" = 5 ]; then
	if [ "$WLAN_WDS_ENCRYPT" = '0' ]; then
		$SET_WLAN_PARAM wds_encrypt=0
	elif [ "$WLAN_WDS_ENCRYPT" = '1' ]; then
		if [ "$WEP" = '1' ]; then
			$SET_WLAN_PARAM wds_encrypt=1
			$SET_WLAN_PARAM wds_wepkey=$WEP64_KEY1
		else
			$SET_WLAN_PARAM wds_encrypt=5
			$SET_WLAN_PARAM wds_wepkey=$WEP128_KEY1
		fi
	elif [ "$WLAN_WDS_ENCRYPT" = '2' ]; then
		if [ "$WLAN_WDS_WPA_CIPHER_SUITE" = 1  ]; then
			$SET_WLAN_PARAM wds_encrypt=2
		else
			$SET_WLAN_PARAM wds_encrypt=4
		fi
		$SET_WLAN_PARAM wds_passphrase="$WLAN_WDS_WPA_PSK"
	fi
else
	$SET_WLAN_PARAM wds_enable=0
fi

# enable/disable the notification for IAPP
if [ "$IAPP_DISABLED" = 0 ]; then
	$SET_WLAN_PARAM iapp_enable=1
else
	$SET_WLAN_PARAM iapp_enable=0
fi

#set band
#EDX BAND 1:B; 2:N; 3:B+G; 4:G; 5:B+G+N
$SET_WLAN_PARAM deny_legacy=0
if [ "$BAND" = '5' ]; then
	BAND=11
	basicRate=15
elif [ "$BAND" = '4' ]; then
	BAND=3
	basicRate=351
	$SET_WLAN_PARAM deny_legacy=1
elif [ "$BAND" = '3' ]; then
	BAND=3
	basicRate=15
elif [ "$BAND" = '2' ]; then
	BAND=11
	basicRate=15
	$SET_WLAN_PARAM deny_legacy=1
elif [ "$BAND" = '6' ]; then
	BAND=11
	basicRate=496
	$SET_WLAN_PARAM deny_legacy=1
	$SET_WLAN_PARAM oprates=4080
else
	BAND=1
	basicRate=3
fi
$SET_WLAN_PARAM band=$BAND
$SET_WLAN_PARAM basicrates=$basicRate
###Set 11n parameter
if [ $BAND = 10 ] || [ $BAND = 11 ]; then
	if [ $WLAN_N_CHAN_WIDTH = 0 ]; then
		$SET_WLAN_PARAM use40M=1
	else
		$SET_WLAN_PARAM use40M=0
	fi
	if [ $CHANNEL -ge 7 ]; then
		$SET_WLAN_PARAM 2ndchoffset=1

	else
		$SET_WLAN_PARAM 2ndchoffset=2
	fi
	
	if [ "$_MODE_" = "PCI" ] || [ "$_MODE_" = "Buffalo" ]; then
		$SET_WLAN_PARAM shortGI20M=`expr 1 - $SHORTGI`
		$SET_WLAN_PARAM shortGI40M=`expr 1 - $SHORTGI`
		$SET_WLAN_PARAM ampdu="`expr 1 - $AGGREGATION`"
		$SET_WLAN_PARAM amsdu="`expr 1 - $AGGREGATION`"
	else
		$SET_WLAN_PARAM shortGI20M=1
		$SET_WLAN_PARAM shortGI40M=1
		$SET_WLAN_PARAM ampdu=1
		$SET_WLAN_PARAM amsdu=1
	fi
fi
##########

#set nat2.5 disable when client and mac clone is set
if [ "$MACCLONE_ENABLED" = '1' -a "$AP_MODE" = '1' ]; then
	$SET_WLAN_PARAM nat25_disable=1
	$SET_WLAN_PARAM macclone_enable=1
else
	$SET_WLAN_PARAM nat25_disable=0
	$SET_WLAN_PARAM macclone_enable=0
fi
# set nat2.5 disable and macclone disable when wireless isp mode
if [ "$OP_MODE" != '0' ] ;then
	$SET_WLAN_PARAM nat25_disable=1
	$SET_WLAN_PARAM macclone_enable=0
fi

# set 11g protection mode
if  [ "$PROTECTION_DISABLED" = '1' ] ;then
	$SET_WLAN_PARAM disable_protection=1
else
	$SET_WLAN_PARAM disable_protection=0
fi

# set block relay
eval `$GETMIB WLAN_BLOCK_RELAY`
$SET_WLAN_PARAM block_relay=$WLAN_BLOCK_RELAY

# set WiFi specific mode
#EDX $SET_WLAN_PARAM wifi_specific=$WIFI_SPECIFIC
$SET_WLAN_PARAM wifi_specific=2

# for WMM
if [ "$IsVAP" != "va" ]; then
	eval `$GETMIB WLAN_WMM`
	$SET_WLAN_PARAM qos_enable=$WLAN_WMM
fi

#set MSSID LANWAN ACCESS and WMM
if [ "$_MSSID_" = "y" ]; then
	mssid2.sh $1 setAccessWMM
fi

# for guest access		and   wmm
if [ "$1" = "wlan0" ]; then
eval `$GETMIB WLAN_WMM`
$SET_WLAN_PARAM qos_enable=$WLAN_WMM
fi

#set MSSID LANWAN ACCESS and WMM
if [ "$_MSSID_" = "y" ]; then
	mssid2.sh $1 setAccessWMM
fi
#
# following settings is used when driver WPA module is included
#
#eval `$GETMIB WPA_AUTH`
if [ "$OP_MODE" != '0' ] && [ "$1" = "wlan0" ]; then
	ENABLE=0
	if [ "$STADRV_ENCRYPT_TYPE" = '2' ]; then
		if [ $STADRV_WPA_CIPHER = '0' ]; then
			ENABLE=1
			CIPHER=2
			$SET_WLAN_PARAM wpa_cipher=$CIPHER
			$SET_WLAN_PARAM wpa2_cipher=0
		elif [ $STADRV_WPA_CIPHER = '1' ]; then
			ENABLE=2
			CIPHER=8
			$SET_WLAN_PARAM wpa_cipher=0
			$SET_WLAN_PARAM wpa2_cipher=$CIPHER
		elif [ $STADRV_WPA_CIPHER = '2' ]; then
			ENABLE=3
			CIPHER=10
			$SET_WLAN_PARAM wpa_cipher=0
			$SET_WLAN_PARAM wpa2_cipher=$CIPHER
		else
			echo "invalid ENCRYPT value!"; exit
			ENABLE=0
			$SET_WLAN_PARAM wpa_cipher=0
			$SET_WLAN_PARAM wpa2_cipher=$CIPHER
		fi
		$SET_WLAN_PARAM passphrase="$STADRV_PSKKEY"
		$SET_WLAN_PARAM gk_rekey=$WLAN_WPA_GROUP_REKEY_TIME
	fi
	$SET_WLAN_PARAM psk_enable=$ENABLE
else
	if [ "$IsVAP" != "va" ]; then # MSSID will do WPA encrypt later
	if [ $AP_MODE != 1 ] && [ $WLAN_ENCRYPT -ge 2 ] && [ $WLAN_WPA_AUTH = 2 ]; then
		if [ $WLAN_ENCRYPT = 2 ]; then
			ENABLE=1
		elif [ $WLAN_ENCRYPT = 4 ]; then
			ENABLE=2
		elif [ $WLAN_ENCRYPT = 6 ]; then
			ENABLE=3
		else
			echo "invalid ENCRYPT value!"; exit
		fi
		$SET_WLAN_PARAM psk_enable=$ENABLE

		CIPHER=0
		if [ $WLAN_ENCRYPT = 2 ] || [ $WLAN_ENCRYPT = 6 ]; then
			#eval `$GETMIB WPA_CIPHER_SUITE`
			if [ $WLAN_WPA_CIPHER_SUITE = 1 ]; then
				CIPHER=2
			elif [ $WLAN_WPA_CIPHER_SUITE = 2 ]; then
				CIPHER=8
			elif [ $WLAN_WPA_CIPHER_SUITE = 3 ]; then
				CIPHER=10
			else
				echo "invalid WPA_CIPHER_SUITE value!"; exit 1
			fi
		fi
		$SET_WLAN_PARAM wpa_cipher=$CIPHER
		CIPHER=0
		if [ $WLAN_ENCRYPT = 4 ] || [ $WLAN_ENCRYPT = 6 ]; then
			#eval `$GETMIB WPA2_CIPHER_SUITE`
			if [ $WPA2_CIPHER_SUITE = 1 ]; then
				CIPHER=2
			elif [ $WPA2_CIPHER_SUITE = 2 ]; then
				CIPHER=8
			elif [ $WPA2_CIPHER_SUITE = 3 ]; then
				CIPHER=10
			else
				echo "invalid WPA2_CIPHER_SUITE value!"; exit 1
			fi
		fi
		$SET_WLAN_PARAM wpa2_cipher=$CIPHER
		$SET_WLAN_PARAM passphrase="$WLAN_WPA_PSK"
		$SET_WLAN_PARAM gk_rekey=$WLAN_WPA_GROUP_REKEY_TIME
	else
		$SET_WLAN_PARAM psk_enable=0
	fi
	fi  #endof if "$1" != "wlan0-va0" .........
fi

#set MSSID WPA Encrypt
if [ "$_MSSID_" = "y" ]; then
	mssid2.sh $1 setMSSIDwpa
fi

if [ "$HW_11N_TRSWITCH" ]; then
	$SET_WLAN_PARAM trswitch=$HW_11N_TRSWITCH  
fi

if [ "$_WIRELESSCLIENTLIMIT_" = "y" ]; then
	$SET_WLAN_PARAM stanum=$WIRELESSCLIENTLIMIT
	if [ "$_MSSID_" = "y" ]; then
		mssid2.sh $1 setWirelessClientLimit
	fi
fi

# -----------WIFI 認證功能設定-------------
if [ "$_MODE_" = "WIFITEST" ]; then
	iwpriv wlan0 set_mib coexist=1
fi
# -----------------------------------------
