#!/bin/sh
CFG_FILE=/etc/Wireless/RT2860/RT2860.dat
. /bin/scriptlib.sh
echo "Default" > $CFG_FILE
echo "CountryRegion=1" >> $CFG_FILE
echo "CountryRegionABand=$HW_COUNTRY_REG_ABAND" >> $CFG_FILE
echo "CountryCode=$HW_COUNTRY_CODE" >> $CFG_FILE
echo "SSID=$STADRV_SSID" >> $CFG_FILE
echo "NetworkType=Infra" >> $CFG_FILE
echo "WirelessMode=$STADRV_BAND" >> $CFG_FILE
echo "Channel=0" >> $CFG_FILE
echo "BasicRate=15" >> $CFG_FILE
echo "BeaconPeriod=$BEACON_INTERVAL" >> $CFG_FILE
echo "TxPower=100" >> $CFG_FILE
echo "BGProtection=$WLAN_CTS" >> $CFG_FILE
echo "TxPreamble=$PREAMBLE_TYPE" >> $CFG_FILE
echo "RTSThreshold=$RTS_THRESHOLD" >> $CFG_FILE
echo "FragThreshold=$FRAG_THRESHOLD" >> $CFG_FILE
echo "TxBurst=0" >> $CFG_FILE
echo "PktAggregate=0" >> $CFG_FILE
echo "WmmCapable=$WLAN_WMM" >> $CFG_FILE
echo "AckPolicy=0;0;0;0" >> $CFG_FILE
case "$STADRV_ENCRYPT_TYPE" in
"0") # NONE
echo "AuthMode=OPEN" >> $CFG_FILE
echo "EncrypType=NONE" >> $CFG_FILE
;;
"1") # WEP
echo "AuthMode=WEPAUTO" >> $CFG_FILE
echo "EncrypType=WEP" >> $CFG_FILE
;;
"2") # WPA pre-shared key
case "$STADRV_WPA_CIPHER" in
"0") # WPA(TKIP)
echo "AuthMode=WPAPSK" >> $CFG_FILE
echo "EncrypType=TKIP" >> $CFG_FILE
;;
"1") # WPA2(AES)
echo "AuthMode=WPA2PSK" >> $CFG_FILE
echo "EncrypType=AES" >> $CFG_FILE
;;
"2") # WPA2MIX
echo "AuthMode=WPAPSKWPA2PSK" >> $CFG_FILE
echo "EncrypType=TKIPAES" >> $CFG_FILE
;;
esac
;;
"3") # WPA RADIUS
case "$STADRV_WPA_CIPHER" in
"0") # WPA(TKIP)
echo "AuthMode=WPA" >> $CFG_FILE
echo "EncrypType=TKIP" >> $CFG_FILE
;;
"1") # WPA2(AES)
echo "AuthMode=WPA2" >> $CFG_FILE
echo "EncrypType=AES" >> $CFG_FILE
;;
"2") # WPA2MIX
echo "AuthMode=WPA1WPA2" >> $CFG_FILE
echo "EncrypType=TKIPAES" >> $CFG_FILE
;;
esac
;;
esac
echo "WPAPSK=$STADRV_PSKKEY" >> $CFG_FILE
echo "DefaultKeyID=`expr $STADRV_WEP_DEFAULT_KEY + 1`" >> $CFG_FILE
echo "Key1Type=`expr 1 - $STADRV_WEP_FORMAT1`" >> $CFG_FILE
echo "Key1Str=$STADRV_WEPKEY1" >> $CFG_FILE
echo "Key2Type=`expr 1 - $STADRV_WEP_FORMAT2`" >> $CFG_FILE
echo "Key2Str=$STADRV_WEPKEY2" >> $CFG_FILE
echo "Key3Type=`expr 1 - $STADRV_WEP_FORMAT3`" >> $CFG_FILE
echo "Key3Str=$STADRV_WEPKEY3" >> $CFG_FILE
echo "Key4Type=`expr 1 - $STADRV_WEP_FORMAT4`" >> $CFG_FILE
echo "Key4Str=$STADRV_WEPKEY4" >> $CFG_FILE
echo "IEEE80211H=1" >> $CFG_FILE
echo "PSMode=CAM" >> $CFG_FILE
echo "FastRoaming=0" >> $CFG_FILE
echo "RoamThreshold=70" >> $CFG_FILE
echo "HT_RDG=1" >> $CFG_FILE
if [ "$STADRV_CHANNEL" -gt "4" ]; then
echo "HT_EXTCHA=0" >> $CFG_FILE
else
echo "HT_EXTCHA=1" >> $CFG_FILE
fi
echo "HT_OpMode=0" >> $CFG_FILE
echo "HT_MpduDensity=5" >> $CFG_FILE
if [ "$WLAN_N_CHAN_WIDTH" = '0' ]; then
echo "HT_BW=1" >> $CFG_FILE
else
echo "HT_BW=0" >> $CFG_FILE
fi
echo "HT_AutoBA=1" >> $CFG_FILE
echo "HT_AMSDU=0" >> $CFG_FILE
echo "HT_BAWinSize=64" >> $CFG_FILE
echo "HT_GI=1" >> $CFG_FILE
if [ "$WLAN_N_FIXRTAE" = '0' ]; then
echo "HT_MCS=33" >> $CFG_FILE
else
nTxRate=`expr $WLAN_N_FIXRTAE - 1`
echo "HT_MCS=$nTxRate" >> $CFG_FILE
fi
setUpWirelessDriver $OP_MODE
wlan_exist=`/sbin/ifconfig -a | /bin/grep "ra0"`
if [ "$wlan_exist" = "" ]; then
echo "LED OFF" > $WLAN_LEC_DEV
fi
if [ "$WLAN_MAC_ADDR" = "000000000000" ]; then
WLAN_MAC_ADDR=$HW_WLAN_ADDR
fi
ifconfig ra0 up
if [ "$STADRV_CLONEMAC" != "000000000000" ]; then
m1=`echo $STADRV_CLONEMAC | cut -b 1-2`
m2=`echo $STADRV_CLONEMAC | cut -b 3-4`
m3=`echo $STADRV_CLONEMAC | cut -b 5-6`
m4=`echo $STADRV_CLONEMAC | cut -b 7-8`
m5=`echo $STADRV_CLONEMAC | cut -b 9-10`
m6=`echo $STADRV_CLONEMAC | cut -b 11-12`
iwpriv ra0 e2p 4=$m2$m1
iwpriv ra0 e2p 6=$m4$m3
iwpriv ra0 e2p 8=$m6$m5
ifconfig ra0 down
ifconfig ra0 up
fi
$SET_WLAN_PARAM ra0 Debug=0
ifconfig ra0 | grep "HWaddr" > /var/wlanTmp
HW_MAC=`cut -f 12 -d" " /var/wlanTmp`
