#!/bin/sh
if [ $# -lt 2 ] || [ $1 != 'start' -a $1 != 'kill' ] ; then
echo "Usage: $0 [start|kill] wlan_interface...br_interface [digest] [qfirst]"
exit 1
fi
WLAN_PREFIX=wlan
START=1
if [ $# -ge 1 ]; then
if [ $1 = 'kill' ]; then
START=0
fi
shift
fi
NAME=`echo $1 | cut -b -4`
WLAN_INTERFACE=
while [ $# -ge 1 -a "$NAME" = "$WLAN_PREFIX" ]
do
WLAN_INTERFACE="$WLAN_INTERFACE $1"
shift
NAME=`echo $1 | cut -b -4`
done
if [ $START = 1 -a $# -lt 1 ]; then
echo "Usage: $0 [start|kill] wlan_interface... bridge_interface [digest] [qfirst]"
exit 1
fi
. /bin/scriptlib.sh
EASYCONF_SCRIPT=autoconf.sh
EASYCONF_DAEMON=autoconf
EASYCONF_CONFIG=/var/autoconf.conf
DEBUG_EASYCONF=
VXD_INTERFACE=
BR_UTIL=brctl
if [ -z "$WLAN_INTERFACE" ]; then
echo 'Error in wlanapp.sh, no wlan interface is given!'
exit 0
fi
PIDFILE=/var/run/iwcontrol.pid
if [ -f $PIDFILE ] ; then
PID=`cat $PIDFILE`
if [ $PID != 0 ]; then
kill -9 $PID
fi
rm -f $PIDFILE
fi
PIDFILE=/var/run/pathsel.pid
if [ -f $PIDFILE ] ; then
PID=`cat $PIDFILE`
if [ $PID != 0 ]; then
kill -9 $PID
fi
rm -f $PIDFILE
$BR_UTIL meshsignaloff
fi
for WLAN in $WLAN_INTERFACE ; do
PIDFILE=/var/run/auth-$WLAN.pid
if [ -f $PIDFILE ] ; then
PID=`cat $PIDFILE`
if [ $PID != 0 ]; then
kill -9 $PID
fi
rm -f $PIDFILE
PIDFILE=/var/run/auth-$WLAN-vxd.pid
if [ -f $PIDFILE ] ; then
PID=`cat $PIDFILE`
if [ "$PID" != 0 ]; then
kill -9 $PID
fi
rm -f $PIDFILE
fi
fi
PIDFILE=/var/run/wscd-$WLAN.pid
if [ -f $PIDFILE ] ; then
PID=`cat $PIDFILE`
if [ $PID != 0 ]; then
kill -9 $PID
fi
rm -f $PIDFILE
fi
echo 0 > /proc/gpio
done
PIDFILE=/var/run/iapp.pid
if [ -f $PIDFILE ] ; then
PID=`cat $PIDFILE`
if [ $PID != 0 ]; then
kill -9 $PID
fi
rm -f $PIDFILE
fi
rm -f /var/*.fifo
if [ $START = 0 ]; then
exit 1
fi
WLAN_ENABLED=0
IAPP_ENABLED=0
DEAMON_CREATED=0
IS_AP=0
IS_CLIENT=0
VALID_WLAN_INTERFACE=
for WLAN in $WLAN_INTERFACE ; do
_ENABLE_1X=0
_USE_RS=0
vapre=`echo "$WLAN" | cut -c 7-8`
VAP=`echo $WLAN | cut -b 7-8`
VAP_AUTH_ENABLE=0
ROOT_AUTH_ENABLE=0
if [ "$AP_MODE" = 3 -o "$AP_MODE" = 4 -o "$AP_MODE" = 5 ] && [ "$WLAN_WDS_ENCRYPT" = '2' ]; then
if [ "$_MSSID_" = 'y' -a "$vapre" = 'va' ]; then
wpaMssidconf.sh wpa $WLAN /var/wpa-wds-$WLAN.conf wds
auth $WLAN $1 wds /var/wpa-wds-$WLAN.conf
PIDFILE=/var/run/auth-$WLAN.pid
while [ -f $PIDFILE ]
do
sleep 1
done
else
flash wpa $WLAN /var/wpa-wds-$WLAN.conf	wds
auth $WLAN $1 wds /var/wpa-wds-$WLAN.conf
PIDFILE=/var/run/auth-$WLAN.pid
while [ -f $PIDFILE ]
do
sleep 1
done
fi
fi
if [ "$_MSSID_" = 'y' -a "$vapre" = 'va' ]; then
nums=`echo "$WLAN" | cut -c 9-9`
nums=`expr $nums + 1`
WLAN_ENCRYPT=`flash get WLAN_ENCRYPT_$nums | cut -d= -f 2`
WLAN_ENABLE_1X=`flash get WLAN_ENABLE_1X_$nums | cut -d= -f 2`
fi
if [ "$WLAN_ENCRYPT" -lt 2 ]; then
if [ "$ENABLE_1X" != 0 ] || [ "$MAC_AUTH_ENABLED" != 0 ]; then
_ENABLE_1X=$WLAN_ENABLE_1X
_USE_RS=1
fi
else
_ENABLE_1X=$WLAN_ENABLE_1X
if [ "$WPA_AUTH" = 1 ]; then
_USE_RS=1
fi
fi
if [ "$AP_MODE" = 9 ]; then
if [ "$AP_MODE" = 6 ] || [ "$AP_MODE" = 7 ] ; then
if [ "$MESH_ENCRYPT" != 0 ]; then
flash wpa $WLAN /var/wpa-$WLAN-msh0.conf msh
auth $WLAN-msh0 $1 wds /var/wpa-$WLAN-msh0.conf
PIDFILE=/var/run/auth-$WLAN-msh0.pid
while [ -f $PIDFILE ]
do
sleep 1
done
fi
fi
fi
ROLE=
if [ "$_ENABLE_1X" != 0 -a "$WLAN_DISABLED" = 0 ]; then
if [ "$_MSSID_" = 'y' -a "$vapre" = 'va' ]; then
wpaMssidconf.sh wpa $WLAN /var/wpa-$WLAN.conf
else
flash wpa $WLAN /var/wpa-$WLAN.conf
fi
if [ "$AP_MODE" = '1' ]; then
if [ "$NETWORK_TYPE" = '0' ]; then
ROLE=client-infra
else
ROLE=client-adhoc
fi
else
ROLE=auth
fi
VAP_NOT_IN_PURE_AP_MODE=0
if [ "$VAP" = "va" ]; then
MODE_BACKUP=$AP_MODE
if [ "$AP_MODE" != 0 -a "$AP_MODE" != 5 ]; then
VAP_NOT_IN_PURE_AP_MODE=1
fi
MODE=$AP_MODE_BACKUP
fi
if [ "$AP_MODE" != '5' ] && [ "$VAP_NOT_IN_PURE_AP_MODE" = '0' ]; then
if [ "$WPA_AUTH" != 2 ] || [ "$_USE_RS" != 0 ]; then
auth $WLAN $1 $ROLE /var/wpa-$WLAN.conf
DEAMON_CREATED=1
if [ "$VAP" = "va" ]; then
VAP_AUTH_ENABLE=1
else
ROOT_AUTH_ENABLE=1
fi
fi
fi
fi
if [ "$VAP" = "vx" ] && [ "$WLAN_DISABLED" = 0 ]; then
if [ "$ROLE" != "auth" ] || [ "$ROLE" = "auth" -a "$_USE_RS" != 0 ]; then
VXD_INTERFACE=$WLAN
fi
fi
if [ "$VAP" = "va" ]; then
if [ "$WLAN_DISABLED" = 0 ]; then
ROOT_IF=`echo $WLAN | cut -b -5`
if [ $IAPP_DISABLED = 0 ] || [ $VAP_AUTH_ENABLE = 1 ]; then
VALID_WLAN_INTERFACE="$VALID_WLAN_INTERFACE $WLAN"
fi
fi
else
if [ "$VAP" != "vx" ]; then
if [ $ROOT_AUTH_ENABLE = 1 ] || [ $IAPP_DISABLED = 0 ] || [ $WSC_DISABLE = 0 ]; then
VALID_WLAN_INTERFACE="$VALID_WLAN_INTERFACE $WLAN"
fi
fi
fi
if [ "$VAP" != "va" ] && [ "$VAP" != "vx" ] ; then
if [ "$WLAN_DISABLED" = 0 ]; then
WLAN_ENABLED=1
fi
if [ "$AP_MODE" = 0 ] || [ "$AP_MODE" = 3 ] || [ "$AP_MODE" = 4 ] || [ "$AP_MODE" = 5 ]; then
IS_AP=1
fi
if [ $IAPP_DISABLED = 0 ]; then
IAPP_ENABLED=1
fi
fi
done
if [ $IAPP_ENABLED = 1 ] && [ "$WLAN_ENABLED" = 1 ] && [ "$IS_AP" = 1 ] ; then
iapp $1 $VALID_WLAN_INTERFACE &
DEAMON_CREATED=1
fi
if [ "$AP_MODE" = 6 ] || [ "$AP_MODE" = 7 ] ; then
if [ "$MESH_ENABLE" = '1' ]; then
pathsel $1 $WLAN_INTERFACE &
fi
fi
if [ -f /bin/netserver ];then
netserver
fi
if [ "$_MSSID_" = 'y' ]; then
WLAN_ENCRYPT=`flash get WLAN_ENCRYPT | cut -d= -f2`
WLAN_ENABLE_1X=`flash get WLAN_ENABLE_1X | cut -d= -f2`
fi
for WLAN in $VALID_WLAN_INTERFACE ; do
if [ $WLAN = "wlan0" ]; then
USE_IWCONTROL=1
DEBUG_ON=0
_ENABLE_1X=0
WSC=1
if [ "$WLAN_ENCRYPT" -lt 2 ]; then
if [ "$WLAN_ENABLE_1X" != 0 ] || [ "$MAC_AUTH_ENABLED" != 0 ]; then
_ENABLE_1X=$WLAN_ENABLE_1X
fi
else
_ENABLE_1X=$WLAN_ENABLE_1X
fi
if [ "$_WPS2_" = "y" ] && [ `flash  all | grep WLAN_ENCRYPT | cut -d "=" -f2 | head -n 1` = 1 ] || [ `flash all |grep WLAN_ENCRYPT | cut -d "=" -f2 | head -n 1` = 2 ] ; then
echo "the encryption does not support WPS2 ,no wscd start"
WSC=0
fi
if [ $WPS_ENABLE != 1 ]; then
WSC=0
if [ "$_MODEL_" = "BR6428GNP" ]; then
ifconfig wlan0 down
ifconfig wlan0 up
fi
else
if [ "$WLAN_DISABLED" != 0 ]; then
WSC=0
else
if [ $AP_MODE = 1 ]; then
if [ "$NETWORK_TYPE" != 0 ]; then
WSC=0
fi
fi
if [ $AP_MODE = 0 ]; then
if [ $WLAN_ENCRYPT -lt 2 ] && [ $_ENABLE_1X != 0 ]; then
WSC=0
fi
if [ $WLAN_ENCRYPT -ge 2 ] && [ $WLAN_WPA_AUTH = 1 ]; then
WSC=0
fi
fi
fi
fi
if [ $WSC = 1 ]; then
if [ ! -f /var/wps/simplecfgservice.xml ]; then
mkdir /var/wps
cp /etc/simplecfg*.xml /var/wps
fi
_CMD="-start"
route del -net 239.255.255.250 netmask 255.255.255.255 "$1" 2>/dev/null
route add -net 239.255.255.250 netmask 255.255.255.255 "$1"
flash upd-wsc-conf /etc/wscd.conf /var/wsc.conf
_CMD="$_CMD -c /var/wsc.conf -w wlan0"
if [ $DEBUG_ON = 1 ]; then
_CMD="$_CMD -debug"
fi
if [ $USE_IWCONTROL = 1 ]; then
_CMD="$_CMD -fi /var/wscd-wlan0.fifo"
DEAMON_CREATED=1
fi
if [ -e /var/wps_start_pbc ]; then
_CMD="$_CMD -start_pbc"
rm -f /var/wps_pbc
fi
if [ -e /var/wps_start_pin ]; then
_CMD="$_CMD -start"
rm -f /var/wps_start_pin
fi
if [ -e /var/wps_local_pin ]; then
PIN=`cat /var/wps_local_pin`
_CMD="$_CMD -local_pin $PIN"
rm -f /var/wps_local_pin
fi
if [ -e /var/wps_peer_pin ]; then
PIN=`cat /var/wps_peer_pin`
_CMD="$_CMD -peer_pin $PIN"
rm -f /var/wps_peer_pin
fi
if [ "$AP_MODE" = "2" ]; then	#Thomas 20100924
WSC_CMD="-mode 2 -c /var/wsc.conf -w wlan0 -fi /var/wscd-wlan0.fifo"
else
WSC_CMD=$_CMD
fi
killall wscd 2>/dev/null
wscd $WSC_CMD -daemon
WAIT=1
while [ $USE_IWCONTROL != 0 -a $WAIT != 0 ]
do
if [ -e /var/wscd-wlan0.fifo ]; then
WAIT=0
else
sleep 1
fi
done
fi
fi
done
if [ "$_WPS_Daemon_" = "y" ] && [ "$WPS_ENABLE" = "1" ] && [ "$WPS_CONFIG_STATUS" = "0" ]; then
kill -9 `pidof wps_daemon.sh`
/bin/wps_daemon.sh &
fi
if [ $DEAMON_CREATED = 1 ]; then
iwcontrol $VALID_WLAN_INTERFACE $VXD_INTERFACE $POLL
fi
if [ $WLAN_ENCRYPT = 7 ]; then
if [ $WAPI_AUTH = 1 ]; then
$KILLALL $ASESERVER 2>/dev/null
$KILLALL $AECLIENT 2>/dev/null
if [ $WAPI_ASIPADDR = $IP_ADDR ]; then
$ASESERVER &
fi
$AECLIENT $WAPI_ASIPADDR &
fi
else
$KILLALL $ASESERVER 2>/dev/null
$KILLALL $AECLIENT 2>/dev/null
fi
