#!/bin/sh
rootDir=`pwd`
rm -f define
if [ "$1" = "BR6228GN" ]; then
	ln -s define-1T1R define 
else
	ln -s define-2T2R define 
fi
if [ `echo $4 |grep "8198" |wc -l` == 1 ];then
crossDir=${rootDir}/toolchain/rsdk-1.3.6-5281-EB-2.6.30-0.9.30
else
crossDir=${rootDir}/toolchain/rtl8196c-toolchain-1.1/rsdk-96c
fi
if [ `echo $4 |grep "CS" |wc -l` == 1 ];then
linuxDir=${rootDir}/linux-2.4.18_1200_96CS
elif [ `echo $4 |grep "1200" |wc -l` == 1 ];then
linuxDir=${rootDir}/linux-2.4.18_1200_96C
else
linuxDir=${rootDir}/linux-2.6.30_2500
fi
appDir=${rootDir}/AP
echo "ROOTDIR=$rootDir" > ./define/PATH
echo "CROSSDIR=$crossDir" >> ./define/PATH
echo "CROSS_COMPILE=${crossDir}/bin/rsdk-linux-" >> ./define/PATH
echo "LINUXDIR=${linuxDir}" >> ./define/PATH
echo "IMAGEDIR=${rootDir}/image" >> ./define/PATH
echo "APPDIR=${appDir}" >> ./define/PATH
echo "MODDIR=${appDir}/module/" >> ./define/PATH
echo "ROMFSDIR=${appDir}/mkimg/romfs" >> ./define/PATH
echo "GOAHEADDIR=${appDir}/goahead-2.1.1" >> ./define/PATH
echo "APPLIB=${crossDir}/lib" >> ./define/PATH
echo "CC=${crossDir}/bin/rsdk-linux-gcc" >> ./define/PATH
echo "STRIP=${crossDir}/bin/rsdk-linux-strip" >> ./define/PATH
echo "LD=${crossDir}/bin/rsdk-linux-ld" >> ./define/PATH
echo "AR=${crossDir}/bin/rsdk-linux-ar" >> ./define/PATH
echo "RANLIB=${crossDir}/bin/rsdk-linux-ranlib" >> ./define/PATH
if [ ! -f "./define/PATH" ]; then
echo "Error can't find ./define/PATH"
exit 0
fi
. ./define/PATH
LANG=eng
STR_DATE1=`date`
echo -e "\033[33;1m"
echo "********************************************************************************"
echo "*                       Function Define                                        *"
echo "********************************************************************************"
echo -e "\033[0m"
. ./define/FUNCTION_SCRIPT
if [ "$_START_BOA_" = "y" ]; then
sed -i "s/goahead-2.1.1/boa-0.94.14rc21/g" ./define/PATH
. ./define/PATH
fi
echo -e "\033[33;1m"
echo "********************************************************************************"
echo "*                       Application need clean                                 *"
echo "********************************************************************************"
echo -e "\033[0m"
if [ -f ./define/last_compile ]; then
diff ./define/FUNCTION_COMPILER ./define/last_compile > /dev/null
if [ $? -eq 0 ]; then
platformChanged="0"
else
platformChanged="1"
fi
else
platformChanged="1"
fi
if [ "$5" = "gpl" -o "$6" = "gpl" ]; then
platformChanged="0"
fi
if [ "$platformChanged" = "1" ]; then
if [ `echo $LINUXDIR |grep "2.6" |wc -l` == 1 ];then
KERNEL_V26=1
else
KERNEL_V26=0
fi
rm ./toolchain/rtl8196c-toolchain-1.1/rsdk-96c
cd toolchain/rtl8196c-toolchain-1.1/
if [ $KERNEL_V26 == 1 ];then
ln -s rsdk-1.3.6-4181-EB-2.6.30-0.9.30 rsdk-96c
else
ln -s rsdk-1.3.6-4181-EB-2.4.25-0.9.30 rsdk-96c
fi
cd ../../AP
./DoApp.sh clean
cd ..
fi 
set -e
echo -e "\033[33;1m"
echo ""
echo "********************************************************************************"
echo "*                            Setting WEB Directory                             *"
echo "********************************************************************************"
echo -e "\033[0m"
rm -f ${GOAHEADDIR}/web
if [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
WEB_DIR="web-ap-Customer"
elif [ "$_MODE_" = "Customer" ]; then
WEB_DIR="web-gw-CustomerOBM"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6408GNS" ]; then
WEB_DIR="web-gw-Customer6408GNS"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6408HAN" ]; then
WEB_DIR="web-gw-Customer6408HAN"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6228GN" ]; then
WEB_DIR="web-gw-Customer6228GN"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6428GN" ]; then
WEB_DIR="web-gw-Customer6428GN"
elif [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
WEB_DIR="web-gw-General"
elif [ "$_MODE_" = "Customer" ] || [ "$_MODE_" = "Customer" ]; then
WEB_DIR="web-gw-Customer_EZSetup"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258N+" ]; then
WEB_DIR="web-gw-CustomerOBM"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6428GNP" ]; then
WEB_DIR="web-gw-Customer_GNP"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258GNL" ]; then
WEB_DIR="web-gw-General-BR6258GNL"
elif [ "$_MODE_" = "Customer" ] && [ "$_MODEL_" = "BR6258NL" ]; then
WEB_DIR="web-gw-CustomerOBM-BR6258NL"
elif [ "$_IS_GATEWAY_" = "y" ]; then
if [ "$_WEB_FILE_NAME_" != "" ]; then
WEB_DIR="web-gw-${_WEB_FILE_NAME_}-${_MODE_}"
else
WEB_DIR="web-gw-${_MODE_}"
fi
else
WEB_DIR="web-ap-${_MODE_}"
fi
if [ "$_LANGUAGE_PACK_" ]; then
WEB_DIR=${WEB_DIR}_with_LanguagePack
fi
if [ -d "${GOAHEADDIR}/${WEB_DIR}" ]; then
ln -s ${GOAHEADDIR}/${WEB_DIR} ${GOAHEADDIR}/web
case "$_MODE_" in
"Customer330" | "Customer331")
rm -rf ${GOAHEADDIR}/${WEB_DIR}/pictures/header_312.png
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/de.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/es.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/fr.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/nl.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/pt.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/uk.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/dk.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/fi.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/it.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/no.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/lang/se.txt
rm -rf ${GOAHEADDIR}/${WEB_DIR}/index.asp
rm -rf ${GOAHEADDIR}/${WEB_DIR}/getlanguage.js
rm -rf ${GOAHEADDIR}/${WEB_DIR}/wpsconfig.asp
if [ "$_MODE_" = "Customer" ]; then
tmpvar=330
fi
if [ "$_MODE_" = "Customer" ]; then
tmpvar=331
cp ${GOAHEADDIR}/${WEB_DIR}/wpsconfig331.asp ${GOAHEADDIR}/${WEB_DIR}/wpsconfig.asp
fi
cp ${GOAHEADDIR}/${WEB_DIR}/pictures/header_${tmpvar}.png ${GOAHEADDIR}/${WEB_DIR}/pictures/header_312.png
cp ${GOAHEADDIR}/${WEB_DIR}/lang/de${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/de.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/es${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/es.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/fr${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/fr.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/nl${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/nl.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/pt${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/pt.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/uk${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/uk.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/dk${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/dk.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/fi${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/fi.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/it${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/it.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/no${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/no.txt
cp ${GOAHEADDIR}/${WEB_DIR}/lang/se${tmpvar}.txt ${GOAHEADDIR}/${WEB_DIR}/lang/se.txt
cp ${GOAHEADDIR}/${WEB_DIR}/index${tmpvar}.asp ${GOAHEADDIR}/${WEB_DIR}/index.asp
cp ${GOAHEADDIR}/${WEB_DIR}/getlanguage${tmpvar}.js ${GOAHEADDIR}/${WEB_DIR}/getlanguage.js
;;
*)
;;
esac
echo "Set WEB DIR to ${WEB_DIR} successfully..."
else
echo "Can not find ${WEB_DIR}..."
exit 0
fi
if [ "$5" = "gpl" -o "$6" = "gpl" ]; then
echo "WEB_DIR=${WEB_DIR}" >> ${ROOTDIR}/define/PATH
exit
fi
echo -e "\033[33;1m"
echo ""
echo "********************************************************************************"
echo "*                      Setting Wireless Driver Directory                       *"
echo "********************************************************************************"
echo -e "\033[0m"
echo -e "\033[33;1m"
echo ""
echo "********************************************************************************"
echo "*                      Building Linux Kernel and Modules                       *"
echo "********************************************************************************"
echo -e "\033[0m"
rm -f ${APPDIR}/module/led/*.* 2> /dev/null
cd ${LINUXDIR}
if [ "$KERNEL_V26" != "1" ];then
./DoLinux.sh clean
fi
./DoLinux.sh
if [ $? != 0 ]; then
exit 1
fi
echo -e "\033[33;1m"
echo "********************************************************************************"
echo "*                            Building Applications                             *"
echo "********************************************************************************"
echo -e "\033[0m"
cd ${APPDIR}
./DoApp.sh make
if [ $? != 0 ]; then
exit 1
fi
cp -f ${ROOTDIR}/define/FUNCTION_COMPILER ${ROOTDIR}/define/last_compile
echo -e "\033[33;1m"
echo "********************************************************************************"
echo "*                               Building Image                                 *"
echo "********************************************************************************"
echo -e "\033[0m"
cd ${IMAGEDIR}
./DoImage.sh
if [ $? != 0 ];then
exit 1
fi
STR_DATE2=`date`
echo "Start Time -->"${STR_DATE1}
echo "End Time   -->"${STR_DATE2}
